      PROGRAM TXMAIN 
      implicit none
      double precision Ecm  ! CMS energy
      integer N, Ntot, mode, ier
      integer         MSTP,               MSTI
      double precision          PARP,               PARI
      COMMON /PYPARS/ MSTP(200),PARP(200),MSTI(200),PARI(200)
      integer MSEL,MSELPD,MSUB,KFIN
      double precision CKIN 
      COMMON /PYSUBS/ MSEL,MSELPD,MSUB(500),KFIN(2,-40:40),CKIN(200)
*
      character*12 FRAME, BEAM,TARGET
      data BEAM/'P           '/, TARGET/'P           '/
*...............................................................
      call TXRFL8('trxdat','CKIN(3) =', CKIN(3),  ier) 
      call TXRINT('trxdat','MSTP(52)=', mstp(52), ier)  
      call TXRINT('trxdat','MSTP(51)=', mstp(51), ier) 
      call TXPAREAD  ! read parameters from <txrun.dat> file
      Ecm =  14000.d0     ! CMS energy (in GeV)
c... choice of internal/external process
       call TXPAREAD  ! read parameters from <txrun.dat> file
       call TXRINT('trxdat','Ntot=',  Ntot,  ier)    ! read Ntot 
*** here finish read input data

      call TXPYIN(Ecm)          ! set/read parameters PYTHIA 
* . . . . . . . . 
       mode = -1               ! initialization
       call USRPRO(mode)       ! analysis routines/detector simulation 
       frame='USER'
       call TopRex(FRAME, BEAM, TARGET , Ecm) ! TopRex init.
* . . . . . . . . 
      call PYINIT(frame, BEAM, TARGET, Ecm)
* start main loop
      mode = 0   ! running 
      DO 2222 N = 1, Ntot            !  main routine   
       if(mod(N,1000).eq.1) write(*,*)' event no=', N 
         call PYEVNT 
         call USRPRO(mode)
 2222 continue 
*
       mode = 1                ! closing
       call PYSTAT(1)     ! brief statistics output from PYTHIA
       call USRPRO(mode) 
      STOP
      END
c----------------------------------------------------------------------------c
*... author Serge Slabospitsky  and  Lars Sonnenschein                       *
*... 07.11.2001                                                              *
*                                                                            *
      Subroutine TXPYIN(ECM)       
*     --------------------------                                             *
*                                                                            *
*  Description: PYTHIA and TopRex initialization                             *
*                                                                            *
*............................................................................*
      implicit none
      EXTERNAL PYDATA
      INTEGER MSTU, MSTJ, KCHG, MDCY, MDME, KFDP, MSEL, MSUB, KFIN,
     &        MSTP, MSTI, MSELPD
      DOUBLE PRECISION
     &  PARU, PARJ, PMAS, PARF, VCKM, BRAT, CKIN, PARP, PARI
      COMMON /PYDAT1/ MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      COMMON /PYDAT2/ KCHG(500,4),PMAS(500,4),PARF(2000),VCKM(4,4)
      COMMON /PYDAT3/ MDCY(500,3),MDME(8000,2),BRAT(8000),KFDP(8000,5)
      COMMON /PYSUBS/ MSEL,MSELPD,MSUB(500),KFIN(2,-40:40),CKIN(200)
      COMMON /PYPARS/ MSTP(200),PARP(200),MSTI(200),PARI(200)
*.......................
      double precision Ecm
      integer IER
      character *80 STROUT
      integer           Ipar  ! global TopRex integer parameters  
      double precision  Rpar  ! global TopRex real    parameters
      common /TXPAR/ Ipar(200), Rpar(200)
*............................................
      MSTP(51) = 7            ! PDF CTEQ5L  (PYTHIA 6.1...)  
*.................masses........
        PMAS(6,1)  = 175.d0     ! top mass
*...KINEMATICS
*
      CKIN(1) = 20.d0    ! default value  for sqrt(Shat)_min
      call TXRFL8('trxdat','CKIN(1) =', CKIN(1),  ier) ! read CKIN(1)
      CKIN(2) = Ecm      ! default value   for sqrt(Shat)_max
      CKIN(3) = 0.d0     ! default value  for PThat_min
       call TXRFL8('trxdat','CKIN(1) =', CKIN(1),  ier) ! read CKIN(3)
      CKIN(4) = Ecm/2.d0 ! default value  for PThat_max
*............................................................................*
* PYTHIA-like prescription for decay channels 
*   W-boson parameters
      call TXRSTR('trxdat','w-boson =', strout, ier) 
      if(ier.ne.1) then
      read(strout(1:80),*) MDME(190,1),MDME(191,1),MDME(194,1), !dU,dC,sU
     &                     MDME(195,1),MDME(198,1),MDME(199,1), !sC,bU,bC
     &                     MDME(206,1),MDME(207,1),MDME(208,1)  !e, mu, tau
      endif
*............................................................................*
*
      return 
      end
*----------------------------------------------------------------------------*
*... author : Serge Slabospitsky 03.12.2003                                  *
*                                                                            *
      subroutine USRPRO(mode) 
*     ---------------------------                                            *
*                                                                            *
*... call analysis routines/detector simulation                              *
* mode = -1, 0, +1  : initialisation, run, closing
*                                                                            *
******************************************************************************

      implicit none
      integer mode 
*...............................................................
      Integer           Ipar  ! global TopRex integer parameters  
      double precision  Rpar  ! global TopRex real    parameters
      common /TXPAR/ Ipar(200), Rpar(200)
*...............................................................
      IF(mode.eq.-1) THEN       ! initialisation 
        Ipar(20) = 1          ! continuation flag (0 is default value)
        IF(Ipar(20).GT.0)  CALL  RNDINP_SRS    !  Get random seed(s) from file 
        call TXHIST(mode)       ! HBOOK initialization
      ELSEIF(mode.eq.0) then    ! running   
        call UseranAlysis 
      ELSEIF(mode.eq.1) then    ! closing
        call TXHIST(mode)
        call RNDOUT_SRS       !...Save random seeds 
      ENDIF
      END
c----------------------------------------------------------------------------c
*CMZ :          01/05/2000  18.08.53  by  Salavat Abdullin
*-- Author :    Salavat Abdullin   12/05/95
*... NO DIFF. from Abdullin's version
*+DOC*******************************************************************
      SUBROUTINE RNDINP_SRS
*
*  Description: reading of the random generator data from the unit LRNDM1
*
*  Arguments
*          In : none
*          Out: none
*        Calls: PYRSET (PYTHIA's internal rndm package)
c----------------------------------------------------------------------------c

      IMPLICIT NONE
      integer LRNDM1
      common /rndio/ lrndm1 

      if(lrndm1.ne.21) lrndm1 = 21

      OPEN (LRNDM1, FILE = 'rnd.data' , FORM = 'UNFORMATTED',
     &      STATUS = 'unknown',ERR=99)
 
      CALL PYRSET(LRNDM1,0)
      goto 1
 99   PRINT '('' RNDINP : can not open rnd.dat file'')'
     
 1    CLOSE(LRNDM1)  
 
      END
*----------------------------------------------------------------------------*
*CMZ :          01/05/2000  18.08.53  by  Salavat Abdullin
*-- Author :    Salavat Abdullin   12/05/95
* srs: (-1) in PYRGET is replaced to (0) 
      SUBROUTINE RNDOUT_SRS
*
*  Description: stores the random generator seed(s) in the unit LRNDM2
*
*  Arguments
*          In : none
*          Out: none
*
*        Calls: PYRGET, standard PYTHIA routine.
*
c----------------------------------------------------------------------------c
      IMPLICIT NONE

      integer LRNDM2
      common /rndio/ lrndm2 
 
      if(lrndm2.ne.21) lrndm2 = 21
      OPEN (LRNDM2, FILE = 'rnd.data', FORM = 'UNFORMATTED',
     &      STATUS = 'UNKNOWN')
 
      CALL PYRGET(LRNDM2,0)      ! SRS modification
 
      CLOSE(LRNDM2)
 
      END
*----------------------------------------------------------------------------*
      SUBROUTINE TXHIST(MODE) 
*...User's historgams booking
*-----------------------------
      implicit none
      integer mode    !, ier
      integer NWPAWC, IPAW 
      integer istat
      parameter         (NWPAWC = 1 000 000)
      COMMON /PAWC/ IPAW(NWPAWC)
*
       IF(mode.EQ.-1) THEN       ! initialisation
        call HLIMIT(NWPAWC)
        call HBSET('BSIZE',4096,ISTAT)               ! Buff. size for columns
         call hbook1(101,'T    cos(L)',100, -1.0,1.0, 0.)
         call hbook1(102,'Tbar cos(L)',100, -1.0,1.0, 0.)
         call hbook2(200,' cos(L1) vs cos(L2) ',20,-1.0,1.0, 
     &                                          20,-1.0,1.0,0.)
***
      ELSEIF(mode.eq.1) THEN                 ! closing
         CALL HCDIR('//PAWC',' ')
         CALL HRPUT(0,'toprex.hist','N')            ! Save user's histograms
      ENDIF
      END

c----------------------------------------------------------------------------*
	Subroutine UseranAlysis 
*	-------------------
      Implicit None
      INTEGER         NN, NPAD, KK
      DOUBLE PRECISION                      PP,         VV
      COMMON /PYJETS/ NN, NPAD, KK(4000,5), PP(4000,5), VV(4000,5)
      integer I
*
      integer iw, il1, kt1, kt2 
      double precision pt1(5), pl1(5), pt2(5), pl2(5) 
      double precision wt, cl1, cl2
      double precision ptt(5), scalp 
      data wt /1.d0/
*            
      kt1 = 0
      kt2 = 0
       do i = 3, NN
        if(kt1.ne.0.AND.kt2.ne.0) goto 21
         if(kk(i,2).eq.6)  kt1 = i   ! top
         if(kk(i,2).eq.-6) kt2 = i   ! topbar
       enddo
      return      ! no top-quark 
 21   continue
*  search for top decay's products
       iw = 0
       do i = (kt1+1), NN
        if(iw.ge.1) goto 22
        if(kk(i,2).eq.24.and.kk(i,3).eq.kt1) iw = i 
       enddo
      return      ! no requested b-quark
 22   continue
       il1 = 0
       do i = (kt1+1), NN
        if(il1.ne.0) goto 23
        if(abs(kk(i,2)).eq.11.and.kk(i,3).eq.iw) il1 = i 
       enddo
       return
 23   continue
       
        do I = 1,4
         Pt1(I) = PP(kt1, I)
         Pl1(I) = PP(il1, I)
        enddo
*  search for topbar decay's products
       iw = 0
       do i = (kt2+1), NN
        if(iw.ge.1) goto 24
        if(kk(i,2).eq.-24.and.kk(i,3).eq.kt2) iw = i 
       enddo
      return      ! no requested W-quark
 24   continue
       il1 = 0
       do i = (kt2+1), NN
        if(il1.ne.0) goto 25
        if(abs(kk(i,2)).eq.11.and.kk(i,3).eq.iw) il1 = i
       enddo
       return
 25    continue
        do I = 1,4
         Pt2(I) = PP(kt2, I)
         Pl2(I) = PP(il1, I)
        enddo
*
* we transit in the tt~ rest frame
       do i=1,4
        ptt(i) = pt1(i) + pt2(i)
       enddo
       ptt(5) = dsqrt(scalp(ptt, ptt))
* spin correlations
        call ttrest(ptt, pt1) 
        call ttrest(ptt, pl1) 
*        
        call ttrest(ptt, pt2) 
        call ttrest(ptt, pl2) 
* histogams
       call costhet (Pt1, pl1, cl1)
       call costhet (Pt2, pl2, cl2)
        call hf1(101, real(cl1), real(wt))
        call hf1(102, real(cl2), real(wt))
        call hf2(200, real(cl1), real(cl2), real(wt))
*
      return
      end
c----------------------------------------------------------------------------*
      subroutine ttrest(ptt, p)
      implicit none
      double precision ptt(5), p(5), ps(5)
      integer i
*
      call lorenf_s(ptt, p, ps)
      do i = 1,4
       p(i) = ps(i)
      enddo
      return
      end  
*----------------------------------------------------------------------------*
*... return cos(theta*), where theta* is the angle between b-momentum        *
*..  direction of first p-momentum in P rest frame                           *
*............................................................................*
      Subroutine costhet (P, B, cost)

      Implicit None
      double precision P(5), B(5), cost, v(5)
      double precision scalp, mt, eb, pb, pp
      integer I
      mt = dsqrt( scalp(p, p) )
      Eb = scalp(p, b) / mt
      pb = dsqrt(Eb*Eb - scalp(b,b))
      pp = dsqrt(p(1)**2 + p(2)**2 + p(3)**2)
       do i = 1,3
        v(i) = (p(4)/mt) * p(i) / pp
       enddo
       v(4) = pp / mt
      cost = -scalp(v,b) / pb
      return
      end

*----------------------------------------------------------------------------*
#include "txread.F"
#include "txinout.F"
