*----------------------------------------------------------------------------*
* Author: Nigel Glover (1989)                                                *
* the original code is based on the article                                  *
* E.W.N. Glver and I.J. Van det Bij, Nucl.Phys. B321 (1989) 561              *
*                                                                            *
* Z-boson decay into fermion pair procedure is written by Serge Slabospitsky *
*                                                         16/02/2005         *
*----------------------------------------------------------------------------*
*      SUBROUTINE A2GGZZ(S,T,U,WTTT,WTTL,WTLL, WTOUT)

      SUBROUTINE A2GGZZ(S,T,U, WTOUT)
      implicit none 
      include "txpar.inc" 
      COMPLEX*16 BI(4),CI(4),DI(3),EPS
      COMPLEX*16 B0,TRI1,TRI2,TRI3,BOX,CRBOX
      COMPLEX*16 APPPP,APPPM,APMPP,APMPM,APPP0,APMP0,APP00,APM00,AHZZ
      COMMON/SMALL/EPS
      double precision EMCUT2, PIE
      double complex RM1
      COMMON/EMCUT/EMCUT2,PIE,RM1

      COMMON/CINTS/BI,CI,DI
      integer NQ, INQ
      double precision EM2, EC2
      COMMON/QUARK/EM2(5),EC2(5,2),NQ
*      double precision XW,AL,ALZ,ALS
*      COMMON/INFO2/XW,AL,ALZ,ALS
*      save /info2/
      double precision pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common /piconst/ pi, pi2, pi4, pi2_3, pi2_4, pi2_6
*
      double precision S, T, U
      double precision EMQ2, BP,BM, A2PB2,A2MB2 !, PT2
      double precision mz2, mz4
      common /masszbos/ mz2, mz4
      integer j1,j2,j3,j4 
      double complex MEX(-1:1,-1:1,-1:1,-1:1)

      double precision coef, WTOUT, WTS0 
      common /ggmex/ coef, WTS0, MEX
      save /ggmex/
      LOGICAL first
      DATA first /.TRUE./
      SAVE first 
      double precision eqf(2,-20:20), zff(2,-20:20)
      common /Vboscpl/ eqf, zff
C
C     FACTOR FOR BOX AMPLITUDE
C     STRONG COUPLING, 4PIE ALPHAS, ELECTROCOUPLING 4PIE ALPHAZ
C
C
C     Ipar(24) = 0 BOX ONLY
C     Ipar(24) = 1 BOX AND HIGGS
C     Ipar(24) = 2 HIGGS ONLY
C
*****
      IF(first) then 
       first = .false.
C     INCLUDE  SPIN SUM 2, COLOUR SUM, 2, COL AVERAGE, 1/64
C     SPIN AVERAGE, 1/4 AND IDENTICAL PARTICLES, 1/2
       coef = Rpar(10) * 2.D0*2.D0/64.D0/4.D0/2.D0/(4.d0*pi)**4
*       coef = 2.d0 * coef ! now Z-bosons are not identical !!! SRS
       coef = coef * BRS(1,4)**2
      ENDIF

      do 123 j1 = -1,1
      do 123 j2 = -1,1
      do 123 j3 = -1,1
      do 123 j4 = -1,1
 123     MEX(j1,j2,j3,j4) = (0.d0, 0.d0)


      DO 100 INQ=1,NQ
        EMQ2=EM2(INQ)
        A2PB2=EC2(INQ,1)
        A2MB2=EC2(INQ,2)
        BI(4)=B0(MZ2,EMQ2)
        BI(1)=B0(S,EMQ2)-BI(4)
        BI(2)=B0(T,EMQ2)-BI(4)
        BI(3)=B0(U,EMQ2)-BI(4)
        CI(1)=TRI1(S,T,U,MZ2,EMQ2)
        CI(2)=TRI2(S,T,U,MZ2,EMQ2)
        CI(3)=TRI2(S,U,T,MZ2,EMQ2)
        CI(4)=TRI3(S,T,U,MZ2,EMQ2)
        DI(2)=BOX(S,T,U,MZ2,EMQ2)
        DI(1)=BOX(S,U,T,MZ2,EMQ2)
        DI(3)=CRBOX(S,T,U,MZ2,EMQ2)
C
C    MULTIPLY BY BOX FACTOR AND PUT IN ELECTRIC CHARGE
C
        BP=DSQRT(1.D0-4.D0*MZ2/S)
        BM=-BP

        IF(Ipar(24).NE.2)THEN
*        TAMP(1)=TAMP(1)+APPPP(S,T,U,MZ2,EMQ2,BP,A2PB2,A2MB2)
*        TAMP(2)=TAMP(2)+APPPP(S,T,U,MZ2,EMQ2,bm,A2PB2,A2MB2)
*        TAMP(3)=TAMP(3)+APPPM(S,T,U,MZ2,EMQ2,BP,A2PB2,A2MB2)
*        TAMP(4)=TAMP(3)
*        TAMP(5)=TAMP(5)+APMPP(S,T,U,MZ2,EMQ2,BP,A2PB2,A2MB2)
*        TAMP(6)=TAMP(5)
*        TAMP(7)=TAMP(7)+APMPM(S,T,U,MZ2,EMQ2,BP,A2PB2,A2MB2)
*        TAMP(8)=TAMP(8)+APMPM(S,T,U,MZ2,EMQ2,bm,A2PB2,A2MB2)
*        TAMP(9)=TAMP(9)  +APPP0(S,T,U,MZ2,EMQ2,BP,A2PB2,A2MB2)
*        TAMP(10)=TAMP(9)
*        TAMP(11)=TAMP(11)+APPP0(S,T,U,MZ2,EMQ2,bm,A2PB2,A2MB2)
*        TAMP(12)=TAMP(11)
*        TAMP(13)=TAMP(13)+APMP0(S,T,U,MZ2,EMQ2,BP,A2PB2,A2MB2)
*        TAMP(14)=TAMP(14)+APMP0(S,T,U,MZ2,EMQ2,bm,A2PB2,A2MB2)
*        TAMP(15)=TAMP(14)
*        TAMP(16)=TAMP(13)
*        TAMP(17)=TAMP(17)+APP00(S,T,U,MZ2,EMQ2,BP,A2PB2,A2MB2)
*        TAMP(18)=TAMP(18)+APM00(S,T,U,MZ2,EMQ2,BP,A2PB2,A2MB2)
*
************************
         MEX(+1,+1,+1,+1) = MEX(+1,+1,+1,+1) 
     &                  + APPPP(S,T,U,MZ2,EMQ2,BP,A2PB2,A2MB2)
         MEX(+1,+1,+1, 0) = MEX(+1,+1,+1, 0) 
     &                  + APPP0(S,T,U,MZ2,EMQ2,BP,A2PB2,A2MB2)
         MEX(+1,+1,+1,-1) = MEX(+1,+1,+1,-1) 
     &                  + APPPM(S,T,U,MZ2,EMQ2,BP,A2PB2,A2MB2)
************
         MEX(+1,+1, 0,+1) = MEX(+1,+1,+1, 0)
*
*         MEX(+1,+1, 0,+1) = MEX(+1,+1, 0,+1) 
*     &                  + APPP0(S,T,U,MZ2,EMQ2,BP,A2PB2,A2MB2)
         MEX(+1,+1, 0, 0) = MEX(+1,+1, 0, 0) 
     &                  + APP00(S,T,U,MZ2,EMQ2,BP,A2PB2,A2MB2)
         MEX(+1,+1, 0,-1) = MEX(+1,+1, 0,-1) 
     &                  + APPP0(S,T,U,MZ2,EMQ2,bm,A2PB2,A2MB2)
***************
         MEX(+1,+1,-1,+1) = MEX(+1,+1,+1,-1)
         MEX(+1,+1,-1, 0) = MEX(+1,+1, 0,-1)
**
*         MEX(+1,+1,-1,+1) = MEX(+1,+1,-1,+1) 
*     &                  + APPPM(S,T,U,MZ2,EMQ2,BP,A2PB2,A2MB2)
*         MEX(+1,+1,-1, 0) = MEX(+1,+1,-1, 0) 
*     &                  + APPP0(S,T,U,MZ2,EMQ2,bm,A2PB2,A2MB2)
         MEX(+1,+1,-1,-1) = MEX(+1,+1,-1,-1) 
     &                  + APPPP(S,T,U,MZ2,EMQ2,bm,A2PB2,A2MB2)
*****************
         MEX(+1,-1,+1,+1) = MEX(+1,-1,+1,+1) 
     &                  + APMPP(S,T,U,MZ2,EMQ2,BP,A2PB2,A2MB2)
         MEX(+1,-1,+1, 0) = MEX(+1,-1,+1, 0)
     &                  + APMP0(S,T,U,MZ2,EMQ2,BP,A2PB2,A2MB2)
         MEX(+1,-1,+1,-1) = MEX(+1,-1,+1,-1) 
     &                  + APMPM(S,T,U,MZ2,EMQ2,BP,A2PB2,A2MB2)
***********
         MEX(+1,-1, 0,+1) = MEX(+1,-1, 0,+1) 
     &                  - APMP0(S,T,U,MZ2,EMQ2,bm,A2PB2,A2MB2)
         MEX(+1,-1, 0, 0) = MEX(+1,-1, 0, 0) 
     &                  + APM00(S,T,U,MZ2,EMQ2,BP,A2PB2,A2MB2)
         MEX(+1,-1, 0,-1) = -MEX(+1,-1,+1, 0)
*         MEX(+1,-1, 0,-1) = MEX(+1,-1, 0,-1) 
*     &                  - APMP0(S,T,U,MZ2,EMQ2,BP,A2PB2,A2MB2)
*************
         MEX(+1,-1,-1,+1) = MEX(+1,-1,-1,+1) 
     &                  + APMPM(S,T,U,MZ2,EMQ2,bm,A2PB2,A2MB2)
         MEX(+1,-1,-1, 0) = -MEX(+1,-1, 0,+1)
         MEX(+1,-1,-1,-1) =  MEX(+1,-1,+1,+1)
*         MEX(+1,-1,-1, 0) = MEX(+1,-1,-1, 0) 
*     &                  + APMP0(S,T,U,MZ2,EMQ2,bm,A2PB2,A2MB2)
*         MEX(+1,-1,-1,-1) = MEX(+1,-1,-1,-1) 
*     &                  + APMPP(S,T,U,MZ2,EMQ2,BP,A2PB2,A2MB2)

        ENDIF
* HIGGS contribution
        IF(INQ.EQ.2.AND.Ipar(24).NE.0)THEN
        AHZZ=+2.D0*EMQ2/(S-Rpar(57)**2+RM1*Rpar(59))*
     &   (-2.D0+(S-4.D0*EMQ2)*CI(1))
         MEX(+1,+1,+1,+1) = MEX(+1,+1,+1,+1) + AHZZ ! TAMP(1)
         MEX(+1,+1,-1,-1) = MEX(+1,+1,-1,-1) + AHZZ ! TAMP(2) 
         MEX(+1,+1, 0, 0) = MEX(+1,+1, 0, 0) 
     &      +(S-2.D0*MZ2)/2.D0/MZ2*AHZZ
        ENDIF
* end HIGGS
 100    continue  ! end main loop

C
C    HIGGS CONTRIBUTION
C
*   99 CONTINUE
*        IF(INQ.EQ.2.AND.Ipar(24).NE.0)THEN
*        AHZZ=+2.D0*EMQ2/(S-EMH2+RM1*GH*EMH)*
*     1   (-2.D0+(S-4.D0*EMQ2)*CI(1))
*        TAMP(1)=TAMP(1)+AHZZ
*        TAMP(2)=TAMP(2)+AHZZ
*        TAMP(17)=TAMP(17)+(S-2.D0*MZ2)/2.D0/MZ2*AHZZ
*        ENDIF
*  100   CONTINUE
C
C       incluDE I PIE**2 FOR B,C,D DEFINITION AND 1/(2PIE)**4 FOR LOOP
C
*      DO 120 I=1,18
*        TAMPI(I)=DREAL(TAMP(I))*BOXFAC/16.D0/PIE**2
*  120   TAMPR(I)=-DIMAG(TAMP(I))*BOXFAC/16.D0/PIE**2
C     DO 125 I=1,18
C 125 WRITE(6,126)I,TAMPI(I),TAMPR(I)
C 126 FORMAT(5X,'( ',I5,2E12.4)
C
C     INCLUDE  SPIN SUM 2, COLOUR SUM, 2, COL AVERAGE, 1/64
C     SPIN AVERAGE, 1/4 AND IDENTICAL PARTICLES, 1/2
C
*      AVFAC=2.D0*2.D0/64.D0/4.D0/2.D0
*      WTTT=0.D0
*      WTTL=0.D0
*      WTLL=0.D0
*      DO 130 I=1,8
*  130 WTTT=WTTT+TAMPI(I)**2+TAMPR(I)**2
*      WTTT=WTTT*AVFAC
*      DO 140 I=9,16
*  140 WTTL=WTTL+TAMPI(I)**2+TAMPR(I)**2
*      WTTL=WTTL*AVFAC
*      DO 150 I=17,18
*  150 WTLL=WTLL+TAMPI(I)**2+TAMPR(I)**2
*      WTLL=WTLL*AVFAC

      WTS0 = 0.d0
*       do 80 J1 = 1,1
       do 80 J2 = 1,2
       do 80 J3 = -1,1
       do 80 J4 = -1,1
 80       WTS0 = WTS0 
     & + MEX(+1, (-3+2*j2),j3,j4)*conjg(MEX(+1, (-3+2*j2),j3,j4))
*      WTS0 = wts0 * avfac * (BOXFAC/16.D0/PIE**2)**2
      WTS0 = wts0 * coef * Rpar(16)**2 
      WTOUT = wts0
      RETURN
      END
