*----------------------------------------------------------------------------*
*.. author : Serge Slabospitsky   09.08.2001                                 *
*....                                                                        *
      subroutine brtwig(plim, mp, gam, wgt, p2s)
*     ------------------------------------------------                       *
*                                                                            *
*  calculate           d p2                                                  *
*              -----------------------,   (pmin)**2  =< p2  =< (pmax)**2     *
*              [(p2 - m2)**2 + gam**2]                                       *
* plim(1) = pmin, plim(2) = pmax are min and max values of sqrt(p**2)        *
* mp is the resonance mass,  gam = m(r) * Gamma(R)_tot                       *
* return :   WGT is total weight(jacobian) and P2S = sqrt(p**2) generated    *
*............................................................................*
      Implicit None
      double precision plim(2), mp, m2, gam, wgt, p2s, t0, del
      double precision pyr
*    plim(1) = pmin     Plim(2) = pmax
*
      m2 = mp**2
      if(plim(1).ge.plim(2)) then 
       p2s = -100.d0
       wgt = 0.d0
       return
      endif
*
      t0  = datan((plim(1)**2 - m2) / gam) 
      del = datan((plim(2)**2 - m2) / gam) - t0
      p2s = dsqrt(m2 + gam * dtan(t0 + del * pyr(0)))
      wgt = del / gam
      return
      end
