*----------------------------------------------------------------------------*
*.. author : Serge Slabospitsky   09.08.2001                                 *
*....                                                                        *
      subroutine brtwig_2(plim, mp, gam, wgt, p2s)
*     ------------------------------------------------                       *
*                                                                            *
*  calculate           d p2                                                  *
*              -----------------------,   (pmin)**2  =< p2  =< (pmax)**2     *
*              [(p2 - m2)**2 + gam**2]                                       *
* plim(1) = pmin, plim(2) = pmax are min and max values of sqrt(p**2)        *
* mp is the resonance mass,  gam = m(r) * Gamma(R)_tot                       *
* return :   WGT is total weight(jacobian) and P2S = sqrt(p**2) generated    *
* for Ipar(32) = 1 zero width approximation is used                          *
*............................................................................*
      Implicit None
      include "txpar.inc" 
      double precision plim(2), mp, m2, gam, wgt, p2s, t0, del
      double precision pyr
      double precision  pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common /piconst / pi, pi2, pi4, pi2_3, pi2_4, pi2_6
*      double precision p1(5), p2(5), phiang 
      LOGICAL first
      DATA first /.TRUE./
      SAVE first
*
      if(first) THEN
       print*,'******************************************'
       print*,'*'
        if(ipar(32).eq.1) print*,
     &'* Breit-Wigner shape is used for resonanse decay chain'
        if(ipar(32).eq.0) print*,
     &'* ZERO width approximation is used for resonanse decay chain'
       print*,'*'
       print*,'******************************************'
       first=.FALSE.
      ENDIF
      wgt = 0.d0
      m2 = mp**2
      if(plim(1).ge.plim(2)) then 
       p2s = -100.d0
       wgt = 0.d0
       return
      endif
*
      
      if(Ipar(32).eq.1) then 
       t0  = datan((plim(1)**2 - m2) / gam) 
       del = datan((plim(2)**2 - m2) / gam) - t0
       p2s = dsqrt(m2 + gam * dtan(t0 + del * pyr(0)))
       wgt = del / gam
      elseif(Ipar(32).eq.0) then
       if(mp.lt.plim(1).OR.mp.gt.plim(2)) then
         print*,'Mass of the resonance is out of ranges',
     &    'in BRTWIG_2'
         print*,'null weight is used. Check the limits'
       endif
       p2s = mp
       wgt = pi / gam
*      print*,' MW gamW ',rpar(41),rpar(43),rpar(44)
      endif       
      
      return
      end
