*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  26.01.2001                                  *
*   W Q Qbar production                                                      *
*   TopReX code = 5                                                          *
*   color flow and showering description for PYTHIA                          *
*............................................................................*
      subroutine COLORF_05(ip1, ip2)
*     ------------------------------                                         *
      implicit none
* PYTHIA6.2 common block for external user's process 
      include "hepeup.inc"
      include "txpar.inc" 
*..................TopReX commons and internal variables
      integer ip1, ip2
*   W-boson decay parameters
      integer kfw, IR, Ires 
* first parameter in MID, BRF, FID, and BRS has the meaning as follows
*     IRES = 1 : top quark,  IRES = 2 : W-boson, 
*     IRES = 3 : H+- boson,  IRES = 4 : Z-boson 
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
      integer kff1, kff2
*..
*................... WQQbar  process  .......................................*
*     g(q) [1]\                                                              *
*              \                 N1[4]                                       *
*               \              /                                             *
*                \  W*[3]     /                                              *
*                 O\/\/\/\/\/O                                               *
*                /            \                                              *
*               /              \ L1[5]     / Q[6]                            *
*              /    g*                    /                                  *
*             O~~~~~~~~~~~~~~~~~~~~~~~~~~O                                   *
*            /                            \                                  *
*   g(q~)[2]/                              \ Qbar[7]                         *
*............................................................................*
*

*                           4-vectors --> /HEPEUP/

*                1     2   3  4  5        6  7
*       nup=7 ! q(~)  q(~) W  Nu L+-  g*  Q  Qbar
* how PYTHIA will be treated
        istup(3) =  2 ! virtual W*,  mass preserved 
        istup(6) =  1 ! final Q 
        istup(7) =  1 ! final Qbar
* masses
        pup(5,3) = dsqrt(pup(4,3)**2-pup(1,3)**2
     &                 - pup(2,3)**2-pup(3,3)**2)
      if(ip1.eq.1.or.ip1.eq.3.or.ip2.eq.1.or.ip2.eq.3) then
       kfw = -24     ! W- production
      else
       kfw =  24     ! W+ production
      endif
* KF codes
        idup(3)=kfw
        idup(6)= Ipar(7)
        idup(7)=-Ipar(7)
* parent's lines
        mothup(1,1)=0   
        mothup(2,1)=0
         mothup(1,2)=0
         mothup(2,2)=0
          mothup(1,3)=1  ! final W 
          mothup(2,3)=2  !
        mothup(1,6)=1  ! final Q 
        mothup(2,6)=2  !
        mothup(1,7)=1  ! final Qbar 
        mothup(2,7)=2  !
*
* color flow
        ipar(50) = 600  ! new number of current color
        if(idup(1).gt.0) then    ! q1 q_bar2
         icolup(1,1)=ipar(50)+1  !      color  q1     -> Q[6]
         icolup(2,2)=ipar(50)+2  ! anti-color q_bar2 -> Qbar[7]
        else                     ! q_bar1   q2
         icolup(2,1)=ipar(50)+2  !     color  q1     -> Q[6]
         icolup(1,2)=ipar(50)+1  ! anti-color q_bar2 -> Qbar[7]
        endif
         icolup(1,6)=ipar(50)+1  !     color  Q[6]
         icolup(2,7)=ipar(50)+2  ! anti-color Qbar[7]
*
       ires = 2  !  W-boson decay
       call Res_branch(ires, kfw, IR)
* fill masses and HEPEUP information for the fermions from W-boson
        kfw = idup(3) / abs(idup(3))    ! +1(-1) for W+ (W-)
        kff1 = kfw *FID(Ires,IR,1)       ! KF code of first  fermion 
        kff2 = kfw *FID(Ires,IR,2)       ! KF code of second fermion
* color flow
      call colorf_bff(3, 4, kff1,  5, kff2) 
      return
      end
