c----------------------------------------------------------------------------c
*.. author:  Serge Slabospitsky    05.09.2002                                * 
      subroutine colorf_BFF(IV, I1, K1,  I2, K2)
*     -----------------------------------------------                        *
* fill position, mother, and color for NU(U) and L+(Dbar)                    *
* from neutral boson decay                                                   *
* IV       is the position in HEPEUP list of V-boson                         *
* I1, K1 are position in HEPEUP list and KF code or first (NU, U) fermion    *
* I2, K2 are position in HEPEUP list and KF code or second (L+, Dbar) ferm.  *
* it is assumed, that both final fermions will be treated by PYTHIA          *
*   I1 = 0 means, that the final fermions are not added yet in HEPEUP list   *
*   in this case NUP will be increased to NUP_new = NUP_old + 2              *
*............................................................................*
      implicit none
*
      include "hepeup.inc" 
      include "txpar.inc"     
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)

      integer  iv, i1, i2, k1, k2  
*.....
      if(i1.eq.0) then
       i1 = nup + 1   !  added to HEPEUP list
       i2 = nup + 2
       nup = nup + 2
      endif
* mother's position
         istup(i1) = 1
         mothup(1,i1) = iv  ! 1-fermion from V-boson 
         mothup(2,i1) = iv  !
          istup(i2) = 1
          mothup(1,i2)= iv  ! 2-fermion from V-boson
          mothup(2,i2)= iv  !
         idup(i1) = k1
         idup(i2) = k2
* color flow
       pup(5,i1) = mq(ABS(k1))
       pup(5,i2) = mq(ABS(k2)) 
      if (ABS(k1).LE.8) then !  final quarks
        ipar(50) = ipar(50) + 100  ! new current color number
        icolup(1,i1) = (ipar(50) + 1) * (abs(k1)+k1)/2/abs(k1)
        icolup(2,i1) = (ipar(50) + 1) * (abs(k1)-k1)/2/abs(k1)
        icolup(1,i2) = (ipar(50) + 1) * (abs(k2)+k2)/2/abs(k2)
        icolup(2,i2) = (ipar(50) + 1) * (abs(k2)-k2)/2/abs(k2)
      endif 
      RETURN
      END
