*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky    27.02.2004                                * 
      subroutine colorf_t_qV(it) 
*     -------------------------------------                                  *
*  fill information about color flow for two-body top decay                  *
*      t -> q V (gluon or photon)                                            * 
* positions in HEPEUP list are as follows:                                   *
*    (hard process) + q   V(G or A)                                          *
*  IT is position of parent top in HEPEUP list                               *
* internal :                                                                 *
*  IQ, IV are HEPEUP positions of q-quark and V-boson from top (t -> q V) dec*
*............................................................................*
      implicit none
*
      include "txpar.inc"     
      include "hepeup.inc" 
*
      integer mxdc
      parameter (mxdc=20)   
      integer ndec, kdec
      double precision pdm, pdpl
      common /decmom/ pdm(mxdc,5), pdpl(mxdc,4), ndec, kdec(mxdc,3)
      integer  it 
      integer iQ, iV   ! positions of final q and V-boson from top decay
*.....
*
      iQ = NUP + 1   ! quark   position
      iV = NUP + 2   ! V-boson position
* HEPEUP positions for quark
      istup(IQ) = 1
      mothup(1,IQ) = IT          ! mother is top 
      mothup(2,IQ) = IT          ! mother is top 
      idup(iQ)     = kdec(2,1)  ! KF code of the final quark
* HEPEUP positions for gluon (photon)
      istup(IV) = 1
      mothup(1,IV) = IT          ! mother is top 
      mothup(2,IV) = IT          ! mother is top 
      idup(iV)     = kdec(1,1)  ! KF code of the final gluon or photon
* color flow information
      if(kdec(1,1).eq.21)    then            ! gluon
       ipar(50) = ipar(50) + 100      ! new current color
        if(idup(IQ).gt.0) then       !  final QUARK
         icolup(1,IQ) = ipar(50) + 1  !  q :  color comes from gluon
         icolup(2,IQ) = 0             ! 
         icolup(1,IV) = icolup(1,it)  !  g :  color comes from top 
         icolup(2,IV) = icolup(1,IQ)  !  g : Acolor comes from q
        else                          !  final ANTIQUARK
         icolup(1,IQ) = 0             ! 
         icolup(2,IQ) = ipar(50) + 1  !  q : Acolor comes from gluon
         icolup(1,IV) = icolup(2,IQ)  !  g :  color comes from q
         icolup(2,IV) = icolup(2,IT)  !  g : Acolor comes from topbar
        endif
      elseif(kdec(1,1).eq.22) then   ! photon, colors are identical to top 
        icolup(1,IQ) = icolup(1,IT)
        icolup(2,IQ) = icolup(2,IT)
       endif
* momenta 
      call DECHEP(IT, 1, IV) 
      call DECHEP(IT, 2, IQ) 
      NUP = NUP + 2
      return 
      end
