*----------------------------------------------------------------------------*
* routines GEJZER_... evaluate matrix elements squared, momenta of           *
* initial and final final particles and corresponding LIPS                   *
*............................................................................*
*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  26.01.2001                                  *
*     Wg process : 2 -> 2                                                    *
*     TopReX code = 1                                                        *
*............................................................................*

      subroutine gejzer_01(NFP)
      implicit None
      include "txpar.inc" 
      include "txpro.inc" 

      integer NFP   ! number of particles in hard process 
      double precision Pus        ! 4-momenta of user's particles
      common /user_mom/ Pus(20,5)

      double precision Ves, qf(5), p1(5), q1(5), q2(5), qq(5) 
      double precision qff(5), pp1(5), qq1(5), qq2(5)

      double precision            sigrx, xcs
      common/xsecs/sigrx,xcs(-6:6,-6:6)
      double precision pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common/piconst/  pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)

      integer I, J, Bqdir, j1,j2
      double precision  x1, x2, sg, sgs
      double precision  pdfBT(-5:5, -5:5)
      double precision  Veslum, vesQB, vesBQ, ParL(3) ! , TopMV
* 
      logical first
      data first /.TRUE./
      save first
      double precision qpr(5), bpr(5), PYR 
      double precision fqwq
      common /sng1fc/ fqwq(4)   !  is factor for weight  
      integer imatch
      common /wmtch/imatch 
      integer         MSTP,               MSTI 
      double precision          PARP,               PARI      
      COMMON /PYPARS/ MSTP(200),PARP(200),MSTI(200),PARI(200)
*..............

      if(first) THEN
       If( Ipar(1).eq.1.or.txpro(1).eq.1)  then 
* EW top-quark production : t-channel (2->2),   Ipar(1) = 1
* EW top-quark production : s-channel,          Ipar(1) = 4
* EW top-quark production : t-channel (2->2+3), Ipar(1) = 11
        ipar(21) = 1
        if(txsel.eq.1) mstp(143) = 1
       EndIf
       I = 1
       J = 1
       call qflqw(I, J)
      first=.FALSE.
      ENDIF

      imatch = 1
      sigrx=0.d0
        do j1 = -6,6
        do j2 = -6,6
         xcs(j1,j2) = 0.d0
        enddo
        enddo
*
        do j1 = 1,5
         q1(j1) = 0.d0
         q2(j1) = 0.d0
        enddo

      p1(5) = mq(6)
      PARL(1) = p1(5) + 1.d0 ! min sqrt(S_hat) 
      PARL(2) = Rpar(1)      ! max sqrt(S_hat) 
      PARL(3) = Rpar(1)      ! sqrt(S) 

 199  call X1X2GEN(ParL, X1, X2, Veslum, qq1, qq2, QQ)
      
      if(qq1(4).lt.mq(5).or.qq2(4).lt.mq(5)) goto 199 
       if(PYR(0).le.0.5) then
        Bqdir = -1            !     Q B
       else
        Bqdir = +1            !     B Q
       endif
      call kinsng1(QQ, q1, q2, Bqdir)
      sg  = QQ(5)**2
      sgs = QQ(5)
      if(sgs.lt.Parl(1)) return
* new top mass generation
      qf(5) = mq(2)
      call LIPS2 (QQ,  P1, qf, Ves)

* setting Q-scale for PDF( Rpar(3)) and for alpha_s 
      call TXQscale     
      call pdf_BT(x1, x2, pdfBT) 

       veslum = 2.d0 * veslum * ves  * pi2_4 / (2.*sg)  ! 2 due to QB choice
*
      do j = 1,4
       qpr(j) = -qf(j)
      enddo
       qpr(5) =  qf(5)
      if(Bqdir.eq.-1) then     ! Q B
       do j = 1,4
        bpr(j) = -q2(j)
       enddo
        bpr(5) =  q2(5)
        call sng_01(q1, qpr, p1, bpr, vesQB)
        VesBQ = 0.d0
      else                     ! B Q
       do j = 1,4
        bpr(j) = -q1(j)
       enddo
        bpr(5) =  q1(5)
        call sng_01(q2, qpr, p1, bpr, vesBQ)
        VesQB = 0.d0
      endif

      VesQB = VesQB * Veslum 
      VesBQ = VesBQ * Veslum 

*  top production
      do I = 1,4
       J = I
       if(I.eq.1.or.I.eq.3) J = -I
       Xcs( J, 5) = VesQB * pdfBT( J, 5) * fqwq(I) * BRS(1,1)  ! T
       Xcs(-J,-5) = VesQB * pdfBT(-J,-5) * fqwq(I) * BRS(2,1)  ! Tbar 
       Xcs( 5, J) = VesBQ * pdfBT( 5, J) * fqwq(I) * BRS(1,1)  ! T 
       Xcs(-5,-J) = VesBQ * pdfBT(-5,-J) * fqwq(I) * BRS(2,1)  ! Tbar
      enddo

      sigrx=0.d0
      do i=-5,5
        do j=-5,5
          sigrx = sigrx + xcs(i,j)
        enddo
      enddo

* fill momenta array 
       nfp = 4
        call TXTQ1SMR(QQ, p1, qf, pp1, qff)
       do i = 1, 5
        pus(1,i) = qq1(i)
        pus(2,i) = qq2(i)
        pus(3,i) = pp1(i) ! final top 
        pus(4,i) = qff(i)
       enddo
      return
      end
