*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  27.01.2001                                  *
*     tW process                                                             *
*     TopReX code = 3                                                        *
*                                                                            *
      subroutine gejzer_03(NFP)
*     --------------------                                                   *
*............................................................................*
      implicit None
      include "txpar.inc" 
      include "txpro.inc" 
      Integer NFP         ! number of particles in hard process 
      double precision Pus
      common /user_mom/Pus(20,5)
      double precision pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common/piconst/  pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
      double precision            sigrx, xcs
      common/xsecs/sigrx,xcs(-6:6,-6:6)

      double precision PYR 
      double precision  p1(5), pw(5), q1(5), q2(5), qq(5), pp1(5)
      double precision  pq(5), pb(5), PN(5), PL(5), pn1(5), pl1(5) 
      Integer I, Bqdir, j1,j2
      double precision  x1, x2, sg, sgs, Veslum, Ves, vesGU, vesUG
      double precision  pdfbt(-5:5, -5:5)
      double precision  parw(4)           ! parameters for LIPS
      integer ich                         ! mark for W-boson exchange
      save ich
      double precision Parl(3) ! , TopMV
      LOGICAL first
      DATA first /.TRUE./
      SAVE first
*     IT = 1 : top quark,  IT = 2 : W-boson, 
*     IT = 3 : H+- boson,  IT = 4 : Z-boson 
*.......
*
      if(first) THEN
      ich = -1              ! W-boson exchaneg in S-channel
      first=.FALSE.
      ENDIF
 
      sigrx=0.d0
        do j1 = -6,6
        do j2 = -6,6
         xcs(j1,j2) = 0.d0
        enddo
        enddo
*
        do j1 = 1,5
         q1(j1) = 0.d0
         q2(j1) = 0.d0
        enddo
* evaluate of the top on-shell mass
      p1(5) = mq(6)
       PARL(1) = p1(5) + rpar(70)  ! min sqrt(S_hat) 
       PARL(2) = Rpar(1)          ! max sqrt(S_hat) 
       PARL(3) = Rpar(1)          ! sqrt(S) 
      call X1X2GEN( ParL, X1, X2, Veslum, q1, q2, QQ)

      if(q1(4).lt.mq(5).or.q2(4).lt.mq(5)) return
       if(PYR(0).le.0.5) then
       Bqdir = -1            !     G B
       q2(3) = -dsqrt(q2(4)**2 - mq2(5))
       q2(5) =  mq(5)
      else
       Bqdir = +1            !     B G
       q1(3) =  dsqrt(q1(4)**2 - mq2(5))
       q1(5) =  mq(5)
      endif

      call Mass2(q1, q2, sg, sgs)
      if(sgs.lt.Parl(1)) return
*
       qq(5) = sgs
       qq(4) = q1(4) + q2(4)       
       qq(3) = q1(3) + q2(3)       
       qq(2) = q1(2) + q2(2)       
       qq(1) = q1(1) + q2(1)       

      call TXQscale    ! setting Q-scale for PDF( Rpar(3)) and for alpha_s
      call pdf_BT(x1, x2, pdfbt) 

*..Rpar(41): W-boson mass,  Rpar(42) = Rpar(41)**2 
*..Rpar(43): W-boson width, Rpar(44) = M(W) * Width(W)
       ParW(1) = Rpar(41)  ! mass of the first resonance 
       ParW(2) = Rpar(44)  ! Width(W) * M(W) 
       ParW(3) = rpar(70)  ! minimal invariant mass of the final W-boson
       ParW(4) = QQ(5)     ! maximal invariant mass of the final W-boson

      Call LIPS_RES_ONE(QQ, ParW, PW, P1, Ves)
      veslum = veslum * ves * 2.d0  ! 2 due to two choices of b direction
       PN(5) = 0.d0  ! nu  or U-quark
       PL(5) = 0.d0  ! L+- or D-quark
      call LIPS2 (PW, PN, PL, Ves)
      veslum = veslum * ves * pi2_4 / (2.*sg)
      
      if(Bqdir.eq.-1) then     ! G B
        pq(5) = PN(5)
        PB(5) = q2(5)
         do I = 1,4
          pq(I) = -PN(I)
          pb(I) = -q2(I)
         enddo
       Call sng_02(ich, q1, Pq,  PL, p1, PB, vesGU)
       VesUG = 0d0
      else                     ! B G
        pq(5) = PN(5)
        PB(5) = q1(5)
         do I = 1,4
          pq(I) = -PN(I)
          pb(I) = -q1(I)
         enddo
       Call sng_02(ich, q2, Pq,  PL, p1, PB, vesUG)
       VesGU = 0d0
      endif

      vesGU = VesGU * Veslum 
      vesUG = VesUG * veslum 
*                  top      W-boson
      xcs( 0, 5) = BRS(1,1)*BRS(2,2) * vesGU * pdfBT( 0, 5) ! G  B , T  W-  
      xcs( 0,-5) = BRS(2,1)*BRS(1,2) * vesGU * pdfBT( 0,-5) ! G  B~, T~ W+ 
      xcs( 5, 0) = BRS(1,1)*BRS(2,2) * vesUG * pdfBT( 5, 0) ! B  G , T  W-
      xcs(-5, 0) = BRS(2,1)*BRS(1,2) * vesUG * pdfBT(-5, 0) ! B~ G , T~ W+
 
      sigrx = Xcs( 0, 5) + Xcs(0,-5) + Xcs(5,0) + Xcs(-5,0)
* fill momenta matrix
       NFP = 6
        call TXTQ2SMR(QQ, p1, pn, pl, pp1, pn1, pl1)
       do i = 1, 5
        pus(1,i) = q1(i)
        pus(2,i) = q2(i)
        pus(3,i) = pp1(i)           ! top
        pus(4,i) = pn1(i) + PL1(i)   ! final (virtual) W from b-quark 
        pus(5,i) = PN1(i)           ! final f1 f2_bar
        pus(6,i) = PL1(i)           ! from second W
       enddo
      return
      end
