*----------------------------------------------------------------------------*
*... Authors  : Serge Slabospitsky                                           *
*... 26.01.2001                                                              *
*   TopReX process  6                                                        *
*    q q~' -> W+- + H+-  -> tau nu                                           *
*----------------------------------------------------------------------------*
      subroutine gejzer_06(NFP) 
      implicit None
      include "txpar.inc" 
      include "txpro.inc" 
      Integer NFP          ! number of particles in hard process 
      double precision Pus
      common /user_mom/Pus(20,5)
      double precision  pn(5), PL(5), q1(5), q2(5), qq(5)
      double precision  Ves2, vesm
      double precision            sigrx, xcs
      common/xsecs/sigrx,xcs(-6:6,-6:6)
      Integer L, I, J, II, j1,j2
      integer        ju, jd, jt,jb 
      common /isng01/ju, jd, jt,jb 
      double precision mql, mql2
      common/massql/ mql(0:20), mql2(0:20)
      double precision  x1, x2, ves, veslum
      dimension ves(-6:6,-6:6)
      double precision pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common/piconst/  pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      double precision pdfbt(-5:5, -5:5)
      double precision CKM2
      common /CKMD/ CKM2(-6:6,-6:6)
      double precision ParL(3), WR(2)
      save ParL 
      double precision XEST(0:12), aran, PYR
      save  XEST
*
      integer IB(12), IT(12), IQ
       data ib/ 2, 2, 2,   4, 4, 4,  -1, -3, -5,  -1, -3, -5/ 
       data it/-1,-3,-5, - 1,-3,-5,   2,  2,  2,   4,  4,  4/ 
      Save IB, IT
*
      LOGICAL first
      DATA first /.TRUE./
      SAVE first
      double precision hr 
      common /topol1/ hr(4)    ! TAU lepton polarisation vector
*..............

      if(first) then 
 999   format(a80)
*..Rpar(51)     : charged Higgs mass                                         *
*..Rpar(53)     : total charged Higgs decay width                            *
*..RPAR(101)      : sqrt(Shat_MIN) for hard process                          *
*..RPAR(102)      : sqrt(Shat_MAX) for hard process                          *
*
      If(    Ipar(1).eq.6.or.txpro(6).eq.1) then
        ipar(21) = -1                       ! Ipar(1)=6 : W* -> tau nu   
      ElseIf(Ipar(1).eq.9.or.txpro(9).eq.1) then
       ipar(21) = -2                        ! Ipar(1) = 9 : H+- -> tau nu 
      EndIf
       ParL(1) = rpar(101)      ! M(W*)_min for production
       ParL(2) = rpar(102)      ! M(W*)_max for production
      write(*,7051) ParL(1), Parl(2) 
 7051 format(/,'   sqrt(Shat) from ',f8.2,' to ',f8.2)
       if(Parl(1).ge.Parl(2)) then
       write(*,7053)
 7053    format(/,' Shat_min greater than Shat_max : stop running')
        STOP 
       endif
       Parl(3) = Rpar(1)
      ENDIF

      if(first) goto 103  
       goto 104
 103   continue
       II = 0
 102   II = II + 1
      if(ii.gt.Ipar(51)) goto 111
       IQ = 0
 100   IQ = IQ + 1
      if(IQ.GT.12) goto 102

 104  sigrx=0.d0
        do j1 = -6,6
        do j2 = -6,6
         xcs(j1,j2) = 0.d0
        enddo
        enddo
*
* 12 combinations are considered
* 1: u d,  2: u s,  3: u b,  4: c d,  5: c s,  6: c b 
* then two combinations correspond to beam(U) or target(U)

      if(.NOT.first) then  
 106  aran = PYR(0)
       if(aran.ge.xest(12))   goto 106 
       do IQ = 1,12
        if(aran.le.xest(IQ))  goto 105
       enddo 
 105   continue
      if(IQ.LT.0.OR.IQ.GT.12) goto 106
      endif
*
        do j1 = 1,5
         q1(j1) = 0.d0
         q2(j1) = 0.d0
        enddo
*...
 295  continue 
* 
       q1(5) = mql(abs(IB(iq)))
       q2(5) = mql(abs(IT(iq)))

      if(abs(ipar(21)).eq.1)    then 
       WR(1) = Rpar(41)   ! W-boson mass
       WR(2) = Rpar(44)   ! M(W) * Width(W) 
       call X1X2RES( ParL, WR, X1, X2, Veslum, q1, q2, QQ)
      elseif(abs(ipar(21)).eq.2) then 
       WR(1) = Rpar(51)   ! H-boson mass
       WR(2) = Rpar(54)   ! M(H) * Width(H) 
       call X1X2RES( ParL, WR, X1, X2, Veslum, q1, q2, QQ)
      elseif(ipar(21).eq.3) then
       call X1X2GEN( ParL, X1, X2, Veslum, q1, q2, QQ)
      endif

* check 
      if(QQ(5).lt.Parl(1).or.QQ(5).gt.PARL(2)) goto 295 
 296  continue

      Rpar(74) = QQ(5)      ! sqrt(s-hat)  
      Rpar(71) = QQ(5)**2   ! sqrt(s-hat)  
      call TXQscale     ! setting Q-scale for PDF( Rpar(3)) and for alpha_s 
      call pdf_BT(x1, x2, pdfbt)
        pn(5) = mql(16)  ! tau-neutrino
        PL(5) = mql(15)  ! tau-lepton
      call LIPS2 (QQ, pn, pl, Ves2)

      veslum = veslum * ves2 * pi2_4 / (2.* QQ(5) * QQ(5)) 

        do j1 = -6,6
        do j2 = -6,6
         ves(j1,j2) = 0.d0
        enddo
        enddo
*
      JT = 16
      JB = 15 
       if(abs(IB(iq)).eq.2.or.abs(IB(iq)).eq.4) then
         JU = IB(iq)
         JD = IT(iq)
         call sng_01(q1, q2, pn, pl, vesm)
       else
         JU = IT(iq)
         JD = IB(iq)
         call sng_01(q2, q1, pn, pl, vesm)
       endif
      I = IB(iq)
      J = IT(iq)
      Xcs( I, J) = Veslum * vesm * pdfBT( I, J) * CKM2(i,j)
      Xcs(-I,-J) = Veslum * vesm * pdfBT(-I,-J) * CKM2(i,j)

      sigrx=0.d0
      do i=-6,6
        do l=-6,6
          if(.NOT.first) then 
           xcs(i,l) = xcs(i,l) / (xest(IQ) - xest(IQ-1))
          endif
         sigrx = sigrx + xcs(i,l)
        enddo
      enddo

      if(.NOT.first) goto 444
      xest(IQ) = xest(IQ) + sigrx
      goto 100
 111  continue
       
       xest(0) = 0.d0
       do IQ = 1,12
        xest(IQ) = xest(IQ) / ipar(52) 
        xest(0)  = xest(0) + xest(IQ)
       enddo
        xest(1) = xest(1) / xest(0) 
       do IQ = 2,12
        xest(IQ) = xest(IQ) / xest(0) 
        xest(IQ) = xest(IQ) + xest(IQ-1) 
       enddo
       xest(0) = 0.d0
       sigrx = 0.d0
      first=.FALSE.
       return       
 444  continue
      NFP = 5
       do i = 1,5
        pus(1,i) = q1(i)
        pus(2,i) = q2(i)
        pus(3,i) = pn(i) + PL(i)  ! virtual W or Higgs 
        pus(4,i) = pn(i)          ! final neutrino 
        pus(5,i) = PL(i)          ! final tau
       enddo 
      return
      end
