*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  17/01/2006                                  *
*  complex matrix element for the process                                    *
*  g g --> t(pol)  + t_bar(pol) + gamma                                      *
*----------------------------------------------------------------------------*
      subroutine ggttgam(k1, k2, p1, p2, q, hh, ves)
*     ----------------------------------------------                         *
      implicit none
      include "txpar.inc" 
      double precision k1(5), k2(5)         ! momenta of the initial quarks
      double precision p1(5), p2(5), q(5)   ! momenta of the final t, tbar gamma 
      double precision x1(5), x2(5), x3(5), x4(5), x5(5), x6(5)
      double precision Ves, coef, S, TS, eg(5), scalp, r(5) 
      Integer i, if1,if2, ip1, ip2,iga, is
      double complex VR(4,4)
      double complex   TM1(2,2,2,2,2), TM2(2,2,2,2,2), TM3(2,2,2,2,2),
     & TM4(2,2,2,2,2), TM5(2,2,2,2,2), TM6(2,2,2,2,2),
     & TM7(2,2,2,2,2), TM8(2,2,2,2,2), 
     & PR1(4,4),PR2(4,4),PR3(4,4),PR4(4,4)
      double complex PR5(4,4), PR6(4,4) 
      double complex UBP1(2,4),Vp2(2,4),U0,UU1(4,4),uu2(4,4),veg(4,4),
     & ei, a11, a12, a21, a22, b11,b12,b21,b22, UT
      double complex UUG1(4,4), UUG4(4,4)   

      data ei/(0.d0, 1.d0)/
      save ei
      LOGICAL first
      SAVE first, coef
      DATA first /.TRUE./
      double precision hh(3,3) 
      double precision CS, CA, CCH
      save cs,ca
      double precision zn1, zn2, znn
      COMMON /colden/ zn1, zn2
*
      if(first) THEN
        coef = rpar(10) * rpar(12)         ! transform into millibarns * eq**2
        coef = coef / (2.d0 * 2.d0)        ! spins
        coef = coef / 8.d0 / 8.d0   ! color normalization
        coef = coef * (2.d0/3.d0)**2
        cs = 7.d0 / 3.d0
        ca = 3.d0
        first=.FALSE.
      ENDIF

      S   = 2.d0 * SCALP(k1, k2)
      do I=1,4
       x1(i) =  p1(i) + q(i)
       x2(i) =  k2(i) - p2(i)
       x3(i) =  p1(i) - k1(i)
       x4(i) = -p2(i) - q(i)
       x5(i) =  k1(i) - p2(i)
       x6(i) =  p1(i) - k2(i)
       r(i)  =  k2(i) - k1(i)
      enddo
       x1(5) = p1(5)
       x2(5) = x1(5)
       x3(5) = x1(5)
       x4(5) = x1(5)
       x5(5) = x1(5)
       x6(5) = x1(5)
       call PropF(x1, PR1)
       call PropF(x2, PR2)
       call PropF(x3, PR3)
       call PropF(x4, PR4)
       call PropF(x5, PR5)
       call PropF(x6, PR6)
      
      call Dirs2_Ubar(p1, UBP1)
      call Dirs2_V(p2,    VP2)
       call phat(r, VR)

      do 999 if1 = 1,2
      do 999 if2 = 1,2
      do 999 iga  = 1,2
       call vpolgam(iga, is, q, eg)
       call phat(eg, VEG)
      do 999 ip1 = 1,2
      do 999 ip2 = 1,2
* M1
       call prod_2(veg, PR1, UUG1)
        call gamagam(ip1, ip2, PR2, UU1)
       call prod_2(UUG1, UU1, UU2)

       call UBAR_M_U(if1,if2,UBP1, VP2, UU2, U0)
       tm1(ip1,ip2,if1,if2,iga) = U0 
* M2
       call prod_2(pr3, veg, UU2)
       call prod_2(UU2, PR2, UU1)
        call gamagam(ip1, ip2, UU1, UU2)
       call UBAR_M_U(if1,if2,UBP1, VP2, UU2, U0)
       tm2(ip1,ip2,if1,if2,iga) = U0
* M3
       call prod_2(PR4, veg, UUG4)
        call gamagam(ip1, ip2, PR3, UU1)
       call prod_2(uu1, UUG4, uu2)
       call UBAR_M_U(if1,if2,UBP1, VP2, UU2, U0)
       tm3(ip1,ip2,if1,if2,iga) = U0
* M4
        call gamagam(ip1, ip2, PR5, UU1)
       call prod_2(UUG1, UU1, UU2)
       call UBAR_M_U(if1,if2,UBP1, VP2, UU2, U0)
       tm4(ip1,ip2,if1,if2,iga) = U0 
* M5
       call prod_2(pr6, veg, UU2)
       call prod_2(UU2, PR5, UU1)
        call gamagam(ip1, ip2, UU1, UU2)
       call UBAR_M_U(if1,if2,UBP1, VP2, UU2, U0)
       tm5(ip1,ip2,if1,if2,iga) = U0
* M6
        call gamagam(ip1, ip2, PR6, UU1)
       call prod_2(uu1, UUG4, uu2)
       call UBAR_M_U(if1,if2,UBP1, VP2, UU2, U0)
       tm6(ip1,ip2,if1,if2,iga) = U0
* M7 and M8
       if(ip1.eq.ip2) then
        call prod_2(UUG1, VR, UU2)
       call UBAR_M_U(if1,if2,UBP1, VP2, UU2, U0)
       tm7(ip1,ip2,if1,if2,iga) = -U0 / (-s)

        call prod_2(vr, UUG4, UU2)
       call UBAR_M_U(if1,if2,UBP1, VP2, UU2, U0)
       tm8(ip1,ip2,if1,if2,iga) = -U0 / (-s)
       endif
 999    continue


       TS = 0.d0
       zn1 = 0.d0
       zn2 = 0.d0
       do 998 ip1 = 1,2
       do 998 ip2 = 1,2
       do 998 if1 = 1,2
       do 998 if2 = 1,2
       do 998 iga  = 1,2
        U0 = tm1(ip1,ip2,if1,if2,iga) + tm2(ip1,ip2,if1,if2,iga)
     &     + tm3(ip1,ip2,if1,if2,iga) 
        zn1 = zn1 + U0 * conjg(U0)
        U0 =                            tm4(ip1,ip2,if1,if2,iga)
     &     + tm5(ip1,ip2,if1,if2,iga) + tm6(ip1,ip2,if1,if2,iga)
        zn2 = zn2 + U0 * conjg(U0)
        U0 = tm1(ip1,ip2,if1,if2,iga) + tm2(ip1,ip2,if1,if2,iga)
     &     + tm3(ip1,ip2,if1,if2,iga) + tm4(ip1,ip2,if1,if2,iga)
     &     + tm5(ip1,ip2,if1,if2,iga) + tm6(ip1,ip2,if1,if2,iga)

        TS = TS + cs * U0 * conjg(U0)
        U0 = tm1(ip1,ip2,if1,if2,iga) + tm2(ip1,ip2,if1,if2,iga)
     &     + tm3(ip1,ip2,if1,if2,iga) 
     &     - tm4(ip1,ip2,if1,if2,iga) - tm5(ip1,ip2,if1,if2,iga) 
     &     - tm6(ip1,ip2,if1,if2,iga)
     &  + 2.d0*(tm7(ip1,ip2,if1,if2,iga) + tm8(ip1,ip2,if1,if2,iga))
        TS = TS + ca * U0 * conjg(U0)
 998   continue 
        znn = zn1 + zn2
        zn1 = zn1 / znn
        zn2 = zn2 / znn

* polarization       
       do ip1 = 1,3
       do ip2 = 1,3
        hh(ip1,ip2) = 0.d0
       enddo
       enddo
       do 997 ip1 = 1,2
       do 997 ip2 = 1,2
       do 997 iga = 1,2
* 
       if1 = 1
       if2 = 1       
        A11 = tm1(ip1,ip2,if1,if2,iga) + tm2(ip1,ip2,if1,if2,iga)
     &      + tm3(ip1,ip2,if1,if2,iga) + tm4(ip1,ip2,if1,if2,iga)
     &      + tm5(ip1,ip2,if1,if2,iga) + tm6(ip1,ip2,if1,if2,iga)

        B11 = tm1(ip1,ip2,if1,if2,iga) + tm2(ip1,ip2,if1,if2,iga)
     &      + tm3(ip1,ip2,if1,if2,iga) 
     &      - tm4(ip1,ip2,if1,if2,iga) - tm5(ip1,ip2,if1,if2,iga) 
     &      - tm6(ip1,ip2,if1,if2,iga)
     &  + 2.d0*(tm7(ip1,ip2,if1,if2,iga) + tm8(ip1,ip2,if1,if2,iga))
*
       if1 = 1
       if2 = 2       
        A12 = tm1(ip1,ip2,if1,if2,iga) + tm2(ip1,ip2,if1,if2,iga)
     &      + tm3(ip1,ip2,if1,if2,iga) + tm4(ip1,ip2,if1,if2,iga)
     &      + tm5(ip1,ip2,if1,if2,iga) + tm6(ip1,ip2,if1,if2,iga)

        B12 = tm1(ip1,ip2,if1,if2,iga) + tm2(ip1,ip2,if1,if2,iga)
     &      + tm3(ip1,ip2,if1,if2,iga) 
     &      - tm4(ip1,ip2,if1,if2,iga) - tm5(ip1,ip2,if1,if2,iga) 
     &      - tm6(ip1,ip2,if1,if2,iga)
     &  + 2.d0*(tm7(ip1,ip2,if1,if2,iga) + tm8(ip1,ip2,if1,if2,iga))
*
       if1 = 2
       if2 = 1       
        A21 = tm1(ip1,ip2,if1,if2,iga) + tm2(ip1,ip2,if1,if2,iga)
     &      + tm3(ip1,ip2,if1,if2,iga) + tm4(ip1,ip2,if1,if2,iga)
     &      + tm5(ip1,ip2,if1,if2,iga) + tm6(ip1,ip2,if1,if2,iga)

        B21 = tm1(ip1,ip2,if1,if2,iga) + tm2(ip1,ip2,if1,if2,iga)
     &      + tm3(ip1,ip2,if1,if2,iga) 
     &      - tm4(ip1,ip2,if1,if2,iga) - tm5(ip1,ip2,if1,if2,iga) 
     &      - tm6(ip1,ip2,if1,if2,iga)
     &  + 2.d0*(tm7(ip1,ip2,if1,if2,iga) + tm8(ip1,ip2,if1,if2,iga))
*
       if1 = 2
       if2 = 2       
        A22 = tm1(ip1,ip2,if1,if2,iga) + tm2(ip1,ip2,if1,if2,iga)
     &      + tm3(ip1,ip2,if1,if2,iga) + tm4(ip1,ip2,if1,if2,iga)
     &      + tm5(ip1,ip2,if1,if2,iga) + tm6(ip1,ip2,if1,if2,iga)

        B22 = tm1(ip1,ip2,if1,if2,iga) + tm2(ip1,ip2,if1,if2,iga)
     &      + tm3(ip1,ip2,if1,if2,iga) 
     &      - tm4(ip1,ip2,if1,if2,iga) - tm5(ip1,ip2,if1,if2,iga) 
     &      - tm6(ip1,ip2,if1,if2,iga)
     &  + 2.d0*(tm7(ip1,ip2,if1,if2,iga) + tm8(ip1,ip2,if1,if2,iga))
*
* e1_x e2_x  
        u0 = a11 + a21 - a12 - a22
        UT = b11 + b21 - b12 - b22
        cch = cs * u0*conjg(u0) + ca * ut*conjg(ut)
        hh(1,1) = hh(1,1) + cch
* e1_x e2_y  
        u0 = a11 + a21 - ei * (a12 + a22)
        ut = b11 + b21 - ei * (b12 + b22)
        cch = cs * u0*conjg(u0) + ca * ut*conjg(ut)
        hh(1,2) = hh(1,2) + cch
* e1_x e2_z  
        u0 = a12 + a22
        ut = b12 + b22
        cch = cs * u0*conjg(u0) + ca * ut*conjg(ut)
        hh(1,3) = hh(1,3) + 2.d0*cch
***
* e1_y e2_x  
        u0 = a11 - a12 - ei * (a21 - a22)
        ut = b11 - b12 - ei * (b21 - b22)
        cch = cs * u0*conjg(u0) + ca * ut*conjg(ut)
        hh(2,1) = hh(2,1) + cch
* e1_y e2_y  
        u0 = a11 - ei*(a12+a21) - a22
        u0 = b11 - ei*(b12+b21) - b22
        cch = cs * u0*conjg(u0) + ca * ut*conjg(ut)
        hh(2,2) = hh(2,2) + cch
* e1_y e2_z  
        u0 = a12 - ei*a22
        ut = b12 - ei*b22
        cch = cs * u0*conjg(u0) + ca * ut*conjg(ut)
        hh(2,3) = hh(2,3) + 2.d0*cch

* e1_z e2_x  
        u0 = a11 - a12
        ut = b11 - b12
        cch = cs * u0*conjg(u0) + ca * ut*conjg(ut)
        hh(3,1) = hh(3,1) + 2.d0 * cch
* e1_z e2_y  
        u0 = a11 - ei*a12
        ut = b11 - ei*b12
        cch = cs * u0*conjg(u0) + ca * ut*conjg(ut)
        hh(3,2) = hh(3,2) + 2.0 * cch
* e1_z e2_z  
        cch = cs * a12*conjg(a12) + ca * b12*conjg(b12)
        hh(3,3) = hh(3,3) + 4.d0 * cch
 997   continue 
      do ip1 = 1,3
      do ip2 = 1,3
       hh(ip1,ip2) = (hh(ip1,ip2) - TS) / TS
      enddo
      enddo

      ves = coef * rpar(16)**2 * TS 
      return
      end
