
c----------------------------------------------------------------------------*
*... author  :  Serge Slabospitsky                                           *
*... 01.03.2002                                                              *
*... return charge Higgs Yukawa couplings with running quark masses          *
*... at M(H+-)**2                                                            *
*..HCPL(1)  = (m(D)/M_W) * tan(beta)     HCPL(2) = (m(U)/M_W) * cot(beta)    *
*..HCPL(3)  = (m(S)/M_W) * tan(beta)     HCPL(4) = (m(C)/M_W) * cot(beta)    *
*..HCPL(5)  = (m(B)/M_W) * tan(beta)     HCPL(6) = (m(T)/M_W) * cot(beta)    *
*..HCPL(7)  = (m(B4)/M_W) * tan(beta)    HCPL(8) = (m(T4)/M_W) * cot(beta)   *
*..HCPL(11) = (m(e)/M_W)   *tan(beta) HCPL(12) = (m(nu_e)/M_W) * cot(beta)   *
*..HCPL(13) = (m(mu)/M_W)  *tan(beta) HCPL(14) = (m(nu_mu)/M_W) * cot(beta)  *
*..HCPL(15) = (m(tau)/M_W) *tan(beta) HCPL(16) = (m(nu_tau)/M_W) * cot(beta) *
* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .  *
      subroutine HIGCPL 
*     -----------------
      implicit None
      include "txpar.inc" 
      integer IQ, j1
      double precision mqrun, Q2 
      double precision mq, mq2
      common/massql/   mq(0:20), mq2(0:20)
      double precision HCPL,       HCPL2   
      common/HPMCPL/   HCPL(-20:20), HCPL2(-20:20)
*
      Q2 = rpar(51)**2   ! M(H+-)**2
       do j1 = -20,20
        hcpl(j1) = 0.d0
       enddo
      
      do iq = 11,16 
       if(iq.eq.11.or.iq.eq.13.or.iq.eq.15)  then
        HCPL(iq) = mq(iq) * rpar(55)          ! charged lepton 
       elseif(iq.eq.12.or.iq.eq.14.or.iq.eq.16)  then
        HCPL(iq) = mq(iq) / rpar(55)          ! neutrino
       endif
      enddo
      do iq = 1,6
        if(iq.eq.2.or.iq.eq.4.or.iq.eq.6)     then
         HCPL(iq) = mqrun(IQ, Q2) * 1.d0/rpar(55)  !  M(U) * cot(beta) 
        elseif(iq.eq.1.or.iq.eq.3.or.iq.eq.5) then
         HCPL(iq) = mqrun(IQ, Q2) * rpar(55)       !  M(D) * tan(beta) 
        endif
      enddo
      do iq = 1,16 
       HCPL(iq)   = HCPL(iq) / rpar(41) 
       HCPL(-iq)  = HCPL(iq) 
       HCPL2(iq)  = HCPL(iq)**2
       HCPL2(-iq) = HCPL2(iq) 
      enddo
      return
      end
