c----------------------------------------------------------------------------c
*.. author : Serge Slabospitsky   30.01.2001                                 *
*....                                                                        *
      subroutine LIPS_RES_ONE(Q, Par, R, P, Ves)      
*     ------------------------------------------                             *
* LIPS with ONE resonance and one on-shell particle in the final state       *
* denominator from resonance is included                                     *
*                                                                            *
*   Q -> R (-> X1)  P                                                        *
*                                                                            *
*         R2(Q -> R P)                                                       *
*  ----------------------------                                              *
*  [(Q**2 - MR**2)**2 + g1**2]                                               *
*                                                                            *
*  LIPS(P1 -> X1) is not included                                            *
*... input :                                                                 *
*  Q   is  5-momentum of initial system                                      *
*  Par(1) mass of the resonance                                              *
*  Par(2) = g1 = width(R) * Par(1)                                           *
*  Par(3) is minimal invariant mass of the resonace                          *
*  Par(4) is maximal invariant mass of the resonace                          *
*                                                                            *
*... output :                                                                *
*  R  is 5-momentum of resonance, P is  5-momentum of on-shell particle      *
*  ves is the weight                                                         * 
*............................................................................*

      implicit none
      double precision Q(5), Par(4), R(5), P(5)
      double precision pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common /piconst/ pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      double precision ves, Qlim
      double precision plim(2), jacb, r5
*
       Qlim = min(Q(5), Par(4))
        if(Qlim.le.Par(3)) then
         VES = 0.d0
         return
        endif
       plim(1) = par(3)
       plim(2) = Qlim - p(5) 
       call brtwig(plim, par(1), par(2), jacb, r5)
      r(5) = r5
      call LIPS2 (Q, R, P, Ves)
      VES = pi2_3 * ves * jacb 
      return
      end
