*----------------------------------------------------------------------------*
*... author  :  Serge Slabospitsky                                           *
*... 20.02.2002                                                              *
* J.A.M. Vermaseren, S.A. Larin, T. van Ritbergen,                           *
* "The 4-loop quark mass anomalous dimension and the invariant quark  mass"  *
*  Phys. Lett.  B405, 327 (1997), arXiv:hep-ph/9703284                       *
*
*
*............................................................................*
*
      function mqrun(IQ, Q2) 
*     ----------------------
*
      Implicit None
      include "pydat_62.inc"
      include "txpar.inc" 
      double precision  pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common/piconst/   pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      integer IQ
      double precision mqrun 
      double precision Q2, PYalps, alq, alb, cf(6,0:3), gam(6) 
      double precision Q2thr
      double precision mq, mq2
      common/massql/   mq(0:20), mq2(0:20)
      LOGICAL first
      DATA first /.TRUE./
      SAVE first
*......
* we calculate the running values for S, C, B, T quarks only
      
      if(iq.eq.0.or.iq.eq.1.or.iq.eq.2.or.Ipar(6).eq.0) then
*      if(iq.eq.0.or.Ipar(6).eq.0) then
        Mqrun = mq(iq)
        return
      elseif(iq.ge.7)        then
        Mqrun = -1.
        return 
      endif
* 
      if(first) THEN
*
       gam(3) = 4.d0/9.d0    ! s-quark
       cf(3,0) = 1.d0                 
       cf(3,1) = 0.895062d0
       cf(3,2) = 1.37143d0
       cf(3,3) = 1.95168d0
*
       gam(4) = 12.d0/25.d0  ! c-quark
       cf(4,0) = 1.d0                  
       cf(4,1) = 1.01413d0
       cf(4,2) = 1.38921d0
       cf(4,3) = 1.09054d0
*
       gam(5) = 12.d0/23.d0  ! b-quark
       cf(5,0) = 1.d0        
       cf(5,1) = 1.17549d0
       cf(5,2) = 1.50071d0
       cf(5,3) = 0.172478d0
*
       gam(6) = 4.d0/7.d0    ! t-quark
       cf(6,0) = 1.d0       
       cf(6,1) = 1.39796d0 
       cf(6,2) = 1.79348d0
       cf(6,3) =-0.683433d0
      first=.FALSE.
      ENDIF
*
      Q2THR=PARU(113)*MQ2(IQ) 
      if(q2thr.le.paru(114)) q2thr = paru(114)
      if(q2.le.q2thr) then
       Mqrun = mq(iq)
       return
      endif

      alq = PYalps(q2) /pi
      alb = PYalps(q2thr)/pi

      Mqrun = mq(iq) * (alq/alb)**gam(iq) 
     & * (cf(iq,0) + cf(iq,1)*alq + cf(iq,2)*alq**2 + cf(iq,3)*alq**3)
     & / (cf(iq,0) + cf(iq,1)*alb + cf(iq,2)*alb**2 + cf(iq,3)*alb**3)
      return
      end
