*----------------------------------------------------------------------------*
* FCNC vertex  :  q - gluon - top                                            *
* iu FCNC-q-type (1-u, 2-t), q - gluon momentum (ON and OFF shell), k - quark* 
* FINAL TOP quark,    return three complex matrices M1, M2, M3               *
* vertex is parametrize as follows V^mu = gamma^mu.M1 + k^mu.M2 + q^mu.M3    *
* eg is gluon polarization vector, veg = (gamma_nu . eg_nu)                  *
* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .*
      subroutine Q_GLU_T(iuu, p, q, eg, VRT)
*     ----------------------------------------------
      implicit none
      double precision q(5), p(5), scalp, pq, q2, eg(5), egq, egp
      double complex   FL,     FR,      HL,    HR,
     &                 XL,     XR,      YL,    YR
      common /ANOMCPL/FL(20), FR(20), HL(20), HR(20), 
     &                XL(20), XR(20), YL(20), YR(20) 
      integer IU, i1, i2, iuu
      double complex M1(4,4),M2(4,4),M3(4,4), VRT(4,4),VEG(4,4),hq(4,4)
      integer jk1,jk2
*
      do jk1 = 1,4
      do jk2 = 1,4
        M1(jk1,jk2) = (0.d0, 0.d0)
        M2(jk1,jk2) = (0.d0, 0.d0)
        M3(jk1,jk2) = (0.d0, 0.d0)
        VRT(jk1,jk2) = (0.d0, 0.d0)
      enddo
      enddo
*
      call phat(q, hq)
      call phat(eg, Veg)
      iu = 10 + iuu
*
*  M1
       q2  = scalp(q, q)
       pq =  scalp(q, p)
       do i1 = 1,2
         M1(i1,i1)         = -pq * XR(iu) - q2 * YR(iu)
         M1((i1+2),(i1+2)) = -pq * XL(iu) - q2 * YL(iu)
        do i2 = 3,4
         M1(i1,i2) = -2.d0*HL(iu) * hq(i1, i2)
         M1(i2,i1) = -2.d0*HR(iu) * hq(i2, i1)
        enddo
       enddo
* M2
       do i1 = 1,2
        do i2 = 3,4
         M2(i1,i2) = XL(iu) * hq(i1, i2)
         M2(i2,i1) = XR(iu) * hq(i2, i1)
        enddo
       enddo
* M3
       do i1 = 1,2
         M3(i1,i1)         = 2.d0 * HR(iu) 
         M3((i1+2),(i1+2)) = 2.d0 * HL(iu) 
        do i2 = 3,4
         M3(i1,i2) = YL(iu) * hq(i1, i2)
         M3(i2,i1) = YR(iu) * hq(i2, i1)
        enddo
       enddo

      call prod_2(veg, M1, VRT)
      egp = scalp(eg, p)
      egq = scalp(eg, q)
       do i1 = 1,4
       do i2 = 1,4
         VRT(i1,i2) = VRT(i1, i2) + egp * M2(i1,i2) + egq * M3(i1,i2)
       enddo
       enddo
      return
      end
