
c----------------------------------------------------------------------------c
*.. author:  Serge Slabospitsky  24/06/2000                                  *
      subroutine qflqw(QI, QF)
*     ------------------------                                               *
* calculate the flavor of final quark, originated from initial quark         *
* transition into W-boson and quark                                          *
*  q_in(QI) -> Q_fin(QF) W(QI)                                               *
* Input :  QI is PYTHIA code of initial quark                                *
* Output:  FC are factors for weight, calculated at the FIRST call           *
*       :  QF is PYTHIA code of final quark                                  *
*       :  QI PYTHIA code of W-boson                                         *
*............................................................................*
      implicit none
      double precision CKM2   !  V_ij**2
      common /CKMD/ CKM2(-6:6,-6:6)
      double precision fc, fc1(4) 
      common /sng1fc/ fc(4) !  are factors for weight  
      Integer QI, QF, ifl(4,2)
      double precision PYR, aran
      Save IFL
      LOGICAL first
      DATA first /.TRUE./
      SAVE first
*......
      if(first) THEN
*  D-quark
       FC1(1) = CKM2(1,2)
       FC(1)  = FC1(1) + CKM2(1,4)
       IFL(1,1) = 2         ! D -> U
       IFL(1,2) = 4         ! D -> C
*  U-quark
       FC1(2) = CKM2(2,1)
       FC(2)  = FC1(2) + CKM2(2,3)
       IFL(2,1) = 1         ! U -> D
       IFL(2,2) = 3         ! U -> S     we ignore U -> B transition
*  S-quark
       FC1(3)  = CKM2(3,2)
       FC(3)  = FC1(3) + CKM2(3,4)
       IFL(3,1) = 2         ! S -> U
       IFL(3,2) = 4         ! S -> C
*  C-quark
       FC1(4) = CKM2(4,1)
       FC(4)  = FC1(4) + CKM2(4,3)
       IFL(4,1) = 1         ! C -> D
       IFL(4,2) = 3         ! C -> S     we ignore C -> B transition
*
      first=.FALSE.
      ENDIF
       aran = FC(abs(QI)) * PYR(0) 
        if(aran.le.FC1(abs(QI))) then
         QF = IFL(abs(QI), 1)
        else
         QF = IFL(abs(QI), 2)
        endif
       if(QI.lt.0) QF = -QF
*  calculate W-boson code
          if(QI.eq.1.or.QI.eq.3.or.QI.eq.-2.or.QI.eq.-4) then
         QI = -24    ! W-
      elseif(QI.eq.-1.or.QI.eq.-3.or.QI.eq.2.or.QI.eq.4) then
         QI = +24    ! W+ 
        endif
      return
      end
