*----------------------------------------------------------------------------*
*  author: Serge Slabospitsky                                                *
*   26.01.2002                                                               *
*  matrix element for the H+ H-              production process              *
*  q   q~ --> H+  H-                                                         *
*  q1  q2     k1  k2                                                         * 
*............................................................................*
      subroutine qqHH(iq, q1, q2, k1, k2, ves)

      implicit none
      include "txpar.inc" 
      double precision  q1(5), q2(5)        ! initial q and q~ quarks 
      double precision  k1(5), k2(5)        ! final H+ and H- 
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
      double precision Ves, coefQ, coefV, coefI, SCALP
      save coefQ, coefV, coefI 
      double precision a(6), b(6), r(5), x(5) 
*
      double precision kap, kas, KAZ, ad,bd, au,bu, mt2, mu2 
      save kap, kas, KAZ, ad,bd, au,bu 
      double precision qq2,q1r,q2r,q1x,q2x,q1q2,r22,x22,z,rx, q1k1
      double precision TV, TQ, TI, ga, gb
      integer IQ, J
      double precision HCPL,       HCPL2   
      common/HPMCPL/   HCPL(-20:20), HCPL2(-20:20)
      LOGICAL first
      SAVE first
      DATA first /.TRUE./
*......... 
      IF(first) THEN        ! initializing
      first=.FALSE.
c  pure Higgs
*..RPAR(26)     : g = g_weak  = e / sin(theta_W)                             *
*..Rpar(41)     : W-boson mass                                               *
*..Rpar(42)     : Rpar(41)**2                                                *
*..Rpar(55)     : tan(beta)                                                  *
*..Rpar(56)     : (1/tan(beta))                                              *

       coefQ = rpar(10) * rpar(26)**4 / 4. 
       coefQ = coefQ / 4.d0 / 3.d0         ! spin & colors
        coefV = rpar(10) * rpar(13)**4     ! e^4 
        coefV = coefV / 4.d0 / 3.d0        ! spin & colors
       coefI = rpar(10) * rpar(26)**2 * rpar(13)**2 / 2. 
       coefI = coefI / 4.d0 / 3.d0         ! spin & colors
*
*      Rpar(25) =  sin(2*theta_W)
       kap = (rpar(24)-rpar(23))/rpar(25)**2
       kas = (2.d0/3.d0)*rpar(23)
       ad = kap * (-1.d0 +      kas ) 
       bd = kap * ( 1.d0) * kas 
       au = kap * (+1.d0 - 2.d0*kas ) 
       bu = kap * (-2.d0) * kas 
       ga = hcpl(6) 
       gb = hcpl(5)  
      ENDIF
* running

      mt2 = mq2(6)
      mu2 = q1(5)**2
      qq2 = q1(5)**2 + q2(5)**2 + 2.d0*scalp(q1,q2) ! shat
       kaz = qq2 - rpar(46)
       a(1) = (-1.d0/3.d0)/qq2 + kap*ad / kaz ! d 
       b(1) = (-1.d0/3.d0)/qq2 + kap*bd / kaz ! d 
       a(2) = (+2.d0/3.d0)/qq2 + kap*au / kaz ! u 
       b(2) = (+2.d0/3.d0)/qq2 + kap*bu / kaz ! u 
      do J = 1,2
        a(2*j+1) = a(1)
        b(2*j+1) = b(1)
        a(2*j+2) = a(2)
        b(2*j+2) = b(2)
      enddo
      do J = 1,5
       r(j) = k1(j) - k2(j)
       x(j) = q1(j) - k1(j) 
      enddo

      
      q1r = scalp(q1, r) 
      q2r = scalp(q2, r) 
      q1x = scalp(q1, x) 
      q2x = scalp(q2, x) 
      rx  = scalp(r,  x)
      q1q2 = scalp(q1, q2)
      r22  = scalp(r, r) 
      q1k1 = scalp(q1, k1)
      x22  = scalp(x, x)
      z = mq2(6) - x22
*
      TV = 2.d0*(a(iq)**2 + b(iq)**2)*
     & (2.d0*q1r*q2r - q1q2*r22) - 4.d0*mu2*a(iq)*b(iq)*r22
*
      TQ = 0.d0
      TI = 0.d0
      if(IQ.eq.5) then
      TQ = 4.d0*ga**2*gb**2 * (mt2*q1q2-mt2*mu2-mu2*x22) 
     &   + 2.d0*(ga**4+gb**4)*(2.d0*q1x*q2x - x22*q1q2)
     &   + 4.d0*mq(6)*mq(5)*ga*gb*(ga**2+gb**2)*(q2x-q1x)
*
      TI = 4.d0*mq(5)*mq(6)*ga*gb*(a(iq)+b(iq))*(q2r - q1r) 
     & - 4.d0*( b(iq)*ga**2 + a(iq)*gb**2)*mu2*rx
     & + 4.d0*( b(iq)*gb**2 + a(iq)*ga**2) 
     & * (q1x*q2r + q1r*q2x - q1q2*rx) 
      endif
*
       ves = coefV * TV + coefQ * TQ / Z**2 + coefI * TI / Z
      return
      end
