*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  19/11/2006                                  *
*  complex matrix element for the process                                    *
*  q  qabr --> t(pol)  + t_bar(pol)                                          *
* we calculate in t tbar center of mass system!                              *
*----------------------------------------------------------------------------*
      subroutine qqttbar(q1, q2, p1, p2, hh, ves)
*     -------------------------------------------                            *
      implicit none
      include "txpar.inc" 
      double precision q1(5), q2(5)   ! momenta of initial gluons 
      double precision p1(5), p2(5)   ! momenta of final t and tbar 
      DOUBLE COMPLEX ei   
      data ei/(0.d0, 1.d0)/
      double precision Ves, coef, zn1, zn2
      COMMON /colden/ zn1, zn2
      double precision         pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common/piconst/ pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      double precision S, SCALP,sqr,pp1(5),pp2(5),ptt(5)
      double precision hh0, hh(3,3), tm 
      Integer I1, I2, j1,j2
      double complex T1
      double complex bb(2,2,2), U(2,4), V(2,4) 
      LOGICAL first
      SAVE first, coef
      DATA first /.TRUE./
*
      if(first) THEN
        coef = (pi4)**2     ! due to alpha_s
        coef = coef * rpar(10)    ! transform into millibarns
        coef = coef * (2.d0/3.d0/3.d0/2.d0/2.d0) ! colors & spins
        first=.FALSE.
      ENDIF

      S   = 2.d0 * SCALP(q1, q2)
* boost to QQbar rest frame
      sqr = dsqrt(s)
       do i1 = 1,4
        ptt(i1) = p1(i1) + p2(i1)
       enddo
       ptt(5) = dsqrt(scalp(ptt, ptt))
       call lorenf_s(ptt, p1, pp1)
       call lorenf_s(ptt, p2, pp2)
* pp1 and pp2 are in QQbar rest frame

      call Dirs2_Ubar(pp1, U) 
      call Dirs2_V   (pp2, V) 

*  bb(i1,i2,j1) i1,i2 are final fermion's indexes
*                 j1    is  initial quark's indexes: two states
      tm = 0.d0
      do 999 i1 = 1,2
      do 999 i2 = 1,2
       if(ipar(33).eq.0.or.ipar(33).eq.1) goto 991
       if(ipar(33).eq.4.and.i1.eq.1.and.i2.eq.1) goto 991
       if(ipar(33).eq.5.and.i1.eq.1.and.i2.eq.2) goto 991
       if(ipar(33).eq.6.and.i1.eq.2.and.i2.eq.1) goto 991
       if(ipar(33).eq.7.and.i1.eq.2.and.i2.eq.2) goto 991
        goto 999
 991   continue
      bb(i1,i2,1) = U(i1,2)*V(i2,3) - U(i1,4)*V(i2,1)
      bb(i1,i2,2) = U(i1,1)*V(i2,4) - U(i1,3)*V(i2,2)
       tm = tm + bb(i1,i2,1) * conjg(bb(i1,i2,1)) 
     &         + bb(i1,i2,2) * conjg(bb(i1,i2,2)) 
 999  continue  

c      hh0 = TM * 2.d0 / sqr
      hh0 = TM 

       do 956 j1 = 1,3
       do 956 j2 = 1,3
 956     hh(j1,j2) = 0.d0

       do 988 j1 = 1,2
* hh(1,1) xx
        T1 = bb(1,1,j1) + bb(2,1,j1)  
     &     - bb(1,2,j1) - bb(2,2,j1) 
       hh(1,1) = hh(1,1) +      T1*conjg(T1) 
* hh(2,1) : yx
        T1 = bb(1,1,j1) - bb(1,2,j1)  
     & - ei*(bb(2,1,j1) - bb(2,2,j1)) 
       hh(2,1) = hh(2,1)  +     T1*conjg(T1)
* hh(3,1) : zx
        T1 = bb(1,1,j1) - bb(1,2,j1) 
       hh(3,1) = hh(3,1) + 2.d0*T1*conjg(T1)
* hh(1,2) : xy
        T1 = bb(1,1,j1) + bb(2,1,j1)  
     & - ei*(bb(1,2,j1) + bb(2,2,j1)) 
       hh(1,2) = hh(1,2)  +     T1*conjg(T1)
* hh(2,2) : yy
        T1 = bb(1,1,j1) - bb(2,2,j1)  
     & - ei*(bb(1,2,j1) + bb(2,1,j1)) 
       hh(2,2) = hh(2,2)  +     T1*conjg(T1)
* hh(3,2) :zy
        T1 = bb(1,1,j1) - ei*bb(1,2,j1) 
       hh(3,2) = hh(3,2) + 2.d0*T1*conjg(T1)
* hh(1,3) :xz
        T1 = bb(1,2,j1) + bb(2,2,j1)
       hh(1,3) = hh(1,3) + 2.d0*T1*conjg(T1)
* hh(2,3) : yz
        T1 = bb(1,2,j1) - ei*bb(2,2,j1)
       hh(2,3) = hh(2,3) + 2.d0*T1*conjg(T1)
* hh(3,3) : zz
        T1 = bb(1,2,j1) 
       hh(3,3) = hh(3,3) + 4.d0*T1*conjg(T1)
 988   continue
      do i1 = 1,3
      do i2 = 1,3
       hh(i1,i2) = (hh(i1,i2) - hh0) / hh0
      enddo
      enddo
      hh0 = hh0 * 2.d0 / sqr
      ves = coef * rpar(15)**2 * hh0 * 2.d0/sqr
      return
      end
