*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  24/11/2005                                  *
*  complex matrix element for the process                                    *
*  q qbar --> t(pol)  + t_bar(pol) + gamma                                   *
*----------------------------------------------------------------------------*
      subroutine qqttgam(ifl, q1, q2, p1, p2, q, hh, ves)
*     ---------------------------------------------------                    *
      implicit none
      include "txpar.inc" 
      double precision q1(5), q2(5)         ! momenta of the initial quarks
      double precision p1(5), p2(5), q(5)   !momenta of the final t, tbar,gamma 
      double precision x1(5), x2(5), x3(5), x4(5)
      integer I, IFL, IL
      double precision Ves, coef, S, TS, eg(5), scalp
      double precision chr(2), pp12, pp11
      save chr 
      Integer if1,if2, iq1, iq2,ig, is, jj1,jj2
      double complex v1u2(4,4), v2u1(4,4)
       save v1u2, v2u1
      double complex TM(2,2,2,2,2), PR1(4,4),PR2(4,4),PR3(4,4),PR4(4,4)
      double complex UBP1(2,4),Vp2(2,4),U0,UU1(4,4),uu2(4,4),veg(4,4),
     & vubu(4,4), ei, a11, a12, a21, a22

      data ei/(0.d0, 1.d0)/
      save ei
      LOGICAL first
      SAVE first, coef
      DATA first /.TRUE./
      double precision hh(3,3) 
*
      if(first) THEN
*        coef = (4.d0 * pi)**2             ! due to alpha_s
        coef = rpar(10) * rpar(12)         ! transform into millibarns * eq**2
        coef = coef / (2.d0 * 2.d0)        ! spins
        coef = coef * (2.d0 / 3.d0 / 3.d0) ! color normalization
        chr(1) = -1.d0/3.d0
        chr(2) =  2.d0/3.d0
        first=.FALSE.
        do 123 jj1 = 1,4
        do 123 jj2 = 1,4
          v1u2(jj1,jj2) = (0.d0, 0.d0)
 123      v2u1(jj1,jj2) = (0.d0, 0.d0)
       v1u2(2,3) =  2.d0
       v1u2(4,1) = -2.d0 
       v2u1(1,4) =  2.d0
       v2u1(3,2) = -2.d0 

      ENDIF

*      goto 800
      if(abs(ifl).eq.1.or.abs(ifl).eq.3.or.abs(ifl).eq.5) il = 1
      if(abs(ifl).eq.2.or.abs(ifl).eq.4)                  il = 2
      S   = 2.d0 * SCALP(q1, q2)
      do I=1,4
       x1(i) =  p1(i) + q(i)
       x2(i) = -p2(i) - q(i)
       x3(i) =  q1(i) - q(i)
       x4(i) =  q(i)  - q2(i)
      enddo
       pp11 = dsqrt(S)
       pp12 = dsqrt((p1(4)+p2(4))**2 - (p1(1)+p2(1))**2
     &            - (p1(2)+p2(2))**2 - (p1(3)+p2(3))**2)
       x1(5) = p1(5)
       x2(5) = p1(5)
       x3(5) = 0.d0
       x4(5) = 0.d0
       call PropF(x1, PR1)
       call PropF(x2, PR2)
       call PropF(x3, PR3)
       call PropF(x4, PR4)
      
      call Dirs2_Ubar(p1, UBP1)
      call Dirs2_V(p2,    VP2)

      do 999 if1 = 1,2
      do 999 if2 = 1,2
       call GUBARU(if1,if2,UBP1, VP2, VUBU)
      do 999 ig  = 1,2
       call vpolgam(ig, is, q, eg)
       call phat(eg, VEG)
      do 999 iq1 = 1,2
       iq2 = 3 - iq1
* M1
       call prod_2(veg, PR1, UU1)
        if(iq1.eq.1) call prod_2(UU1, v1u2, UU2)
        if(iq1.eq.2) call prod_2(UU1, v2u1, UU2)
       call UBAR_M_U(if1,if2,UBP1, VP2, UU2, U0)
       tm(iq1,iq2,if1,if2,ig) = U0 * chr(2) / pp11
* M2
       call prod_2(PR2, veg, UU1)
        if(iq1.eq.1) call prod_2(v1u2, UU1, UU2)
        if(iq1.eq.2) call prod_2(v2u1, UU1, UU2)
       call UBAR_M_U(if1,if2,UBP1, VP2, UU2, U0)
       tm(iq1,iq2,if1,if2,ig) = tm(iq1,iq2,if1,if2,ig) 
     &          + U0* chr(2) / pp11
* M3
       call prod_2(veg, PR3, UU1)
       call prod_2(UU1, VUBU, UU2)
        if(iq1.eq.1) then
         tm(iq1,iq2,if1,if2,ig) = tm(iq1,iq2,if1,if2,ig) 
     &                - UU2(1,4)*chr(il) * pp11 / pp12**2
        elseif(iq1.eq.2) then
         tm(iq1,iq2,if1,if2,ig) = tm(iq1,iq2,if1,if2,ig) 
     &                + UU2(4,1)*chr(il) * pp11 / pp12**2
        endif
* M4
       call prod_2(VUBU, PR4, UU1)
       call prod_2(UU1, veg,  UU2)
        if(iq1.eq.1) then
         tm(iq1,iq2,if1,if2,ig) = tm(iq1,iq2,if1,if2,ig) 
     &               - UU2(1,4) * chr(il) * pp11 / pp12**2
        elseif(iq1.eq.2) then
         tm(iq1,iq2,if1,if2,ig) = tm(iq1,iq2,if1,if2,ig) 
     &               + UU2(4,1) * chr(il) * pp11 / pp12**2
        endif
 999    continue

       TS = 0.d0
       do 998 iq1 = 1,2
        iq2 = 3 - iq1
       do 998 if1 = 1,2
       do 998 if2 = 1,2
       do 998 ig  = 1,2
        TS = TS 
     &  + tm(iq1,iq2,if1,if2,ig)*conjg(tm(iq1,iq2,if1,if2,ig))
 998   continue 

* polarization       
       do iq1 = 1,3
       do iq2 = 1,3
        hh(iq1,iq2) = 0.d0
       enddo
       enddo
       do 997 iq1 = 1,2
        iq2 = 3 - iq1
       do 997 ig  = 1,2
        a11 = tm(iq1,iq2, 1,1, ig)
        a12 = tm(iq1,iq2, 1,2, ig)
        a21 = tm(iq1,iq2, 2,1, ig)
        a22 = tm(iq1,iq2, 2,2, ig)

* e1_x e2_x  
        u0 = a11 + a21 - a12 - a22
        hh(1,1) = hh(1,1) + u0*conjg(u0)
* e1_x e2_y  
        u0 = a11 + a21 - ei * (a12 + a22)
        hh(1,2) = hh(1,2) + u0*conjg(u0)
* e1_x e2_z  
        u0 = a12 + a22
        hh(1,3) = hh(1,3) + 2.d0*u0*conjg(u0)

* e1_y e2_x  
        u0 = a11 - a12 - ei * (a21 - a22)
        hh(2,1) = hh(2,1) + u0*conjg(u0)
* e1_y e2_y  
        u0 = a11 - ei*(a12+a21) - a22
        hh(2,2) = hh(2,2) + u0*conjg(u0)
* e1_y e2_z  
        u0 = a12 - ei*a22
        hh(2,3) = hh(2,3) + 2.d0*u0*conjg(u0)

* e1_z e2_x  
        u0 = a11 - a12
        hh(3,1) = hh(3,1) + 2.d0*u0*conjg(u0)
* e1_z e2_y  
        u0 = a11 - ei*a12
        hh(3,2) = hh(3,2) + 2.0*u0*conjg(u0)
* e1_z e2_z  
        hh(3,3) = hh(3,3) + 4.d0*a12*conjg(a12)
 997   continue 
      do iq1 = 1,3
      do iq2 = 1,3
       hh(iq1,iq2) = (hh(iq1,iq2) - TS) / TS
      enddo
      enddo

      ves = coef * rpar(16)**2 * TS 
      return
      end
