*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  06.03.2005                                  *
* rotate 5-dim vector in 3-dim  space                                        *
* rotate X-vector (defined in P frame) into Y (in Q-frame)                   *
      subroutine rot3(p, q, x, y)
*     ---------------------------                                            *
      implicit none
      double precision p(5), q(5), x(5), y(5), pv, qv, pp(3), qq(3)
      double precision px, zn
      integer J
*
       Y(5) = X(5)
       Y(4) = X(4)
      pv = dsqrt(p(1)**2+p(2)**2+p(3)**2)
      qv = dsqrt(q(1)**2+q(2)**2+q(3)**2)
      if(pv.le.0.000001d0.or.qv.le.0.000001d0) then
       Y(1) = X(1)    ! too small vector
       Y(2) = X(2)    ! nothing rotate
       Y(3) = X(3)
       return
      endif
       do J = 1,3
        pp(J) = p(j)/pv
        qq(J) = q(j)/qv
       enddo 
      px = pp(1)*x(1) + pp(2)*x(2) + pp(3)*x(3)
      zn = 1 + pp(1)*qq(1) + pp(2)*qq(2) + pp(3)*qq(3)
      if(dabs(zn).le.0.000001d0) then
        do J = 1,3
         Y(J) = X(J) - 2.d0*px*pp(j)
        enddo 
        return
      else
       zn = (px + qq(1)*x(1)+qq(2)*x(2)+qq(3)*x(3))/zn
        do J = 1,3
         Y(J) = X(J) + 2.d0*px*qq(j) - zn*(pp(J)+qq(j))
        enddo 
      endif
      return
      end
