c----------------------------------------------------------------------------c
*  new matrix element for the Wg process : 2 -> 3                            *
*.. author: Serge Slabospitsky                                               *
*.. 09/01/2001                                                               *
*                                                                            *
      subroutine sng_02(ich, q, K1, K2, P, B, ves)
*     --------------------------------------------                           *
*                                                                            *
*  ich = 1   default kinematics : q G -> q' t bbar                           *
*  ich = -1  kinematics for tW  : b G -> t W (-> f f~')                      *
*  gluon q --> q' t* b_bar,     top quark is ON-SHELL                        *
*  q     K1    K2 P  B                                                       *
*                                                                            *
*     G U    -> D    T    Bbar                                               *
*     G Dbar -> Ubar T    Bbar                                               *
*     G Ubar -> Dbar Tbar B                                                  *
*     G D    -> U    Tbar B                                                  *
*............................................................................*
      implicit none
      include "txpar.inc" 
      double precision  q(5), K1(5)  ! momenta of initial gluon and u-quark
      double precision  P(5), K2(5), B(5) 
*          4-momenta of top,  q'     b  
      double precision Ves, coef, scalp
      double precision  pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common/piconst/   pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
* internal variables
      double precision T1, T2, T12, lv(5), vh(3,4), vv(5), hp
      common /topol1/ hp(4)
      double precision bk1, bk2, bq, qk1, qk2, pq, pb, pk1,pk2, omw
*
      integer I, J, ich
      LOGICAL first
      DATA first /.TRUE./
      SAVE first, Coef 
*....
      if(first) THEN
*..RPAR(26)     : g = g_weak  = e / sin(theta_W)                             *
*..RPAR(10)     : 0.38939d0     transformation 1/GeV**2 to mb                *
*..Rpar(41)     : W-boson mass                                               *
*..Rpar(42)     : Rpar(41)**2                                                *
      coef = rpar(10) * 2.d0 * pi * rpar(26)**4 
      if(ich.eq.-1) coef = coef * 3.d0  ! 3 = (u d~) + (c s~) + 3*(e mu tau)
      first=.FALSE.
      ENDIF
*
      bk1 = scalp(b, k1)
      bk2 = scalp(b, k2)
      bq  = scalp(b, q) 
      qk1 = scalp(q, k1)
      qk2 = scalp(q, k2)
      pq  = scalp(p, q)
      pb  = scalp(p, b)
      pk1 = scalp(p, k1)
      pk2 = scalp(p, k2)
      omw = Rpar(42) + 2.d0 * scalp(k1,k2)
*
      T1 = b(5)**2 * (bk1 - qk1) - bq * qk1
       do I = 1,4
        lv(i) = - p(5)*k2(I) * t1 / bq**2
       enddo
      t1 = pk2 * t1 / bq**2
*
      T2 = bk1*(p(5)**2 * (pk2 - qk2) - pq*qk2) / pq**2 
       do I = 1,4
        lv(i) = lv(i) + (bk1/pq**2) * p(5)
     & *(-p(5)**2*k2(I) + (qk2-pk2)*q(i) + pq*k2(i))
       enddo
*
      T12 = (pb*qk1 + pq*bk1 - bq*pk1)*pk2
     & - bk1*(2.d0*pb*pk2 - bq*pk2 - pb*qk2 + pq*bk2)
      t12 = t12 / bq / pq

       do I = 1,4
        lv(i) = lv(i) + (p(5)/bq/pq)
     & *(-(pb*qk1 + pq*bk1 - bq*pk1)*k2(i)
     &   - bk1*(-2.d0*pb*k2(i) + qk2*b(i) + bq*k2(i) - bk2*q(i)))
       enddo

      call vortas(p, vh)
       do i = 1,3
         do j = 1,4
          vv(J) = vh(I,J)
         enddo 
        hp(I) = -scalp(lv,vv) / (t1+t2+t12)
       enddo
      Ves = -rpar(15) * coef * (T1 + T2 + T12 ) 

      if(ipar(33).eq.2) ves = ves * (1.d0-hp(3))/2.d0
      if(ipar(33).eq.3) ves = ves * (1.d0+hp(3))/2.d0

* now Ves is the default |M|^2 without denominator from W-boson propagator
* we transform M^2 for two variants of W-boson exchange
      if    (ich.eq.1) then
       Ves = Ves * bq  / omw / omw 
      elseif(ich.eq.-1) then
       Ves = Ves  ! W-denominator is included in LIPS
      endif
      return
      end
