c----------------------------------------------------------------------------c
*... author  :  Serge Slabospitsky                                           *
*... 10.03.2002                                                              *
*   Top decays                                                               *
*----------------------------------------------------------------------------*
      subroutine T_dec_ini 
*     --------------------                                                   *
* calculate top decay width                                                  *
* t -> H+- b  not considered here                                            *
*............................................................................*

      implicit None
      include "txpar.inc" 
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
*............................................................................*
* first parameter in MID, BRF, FID, and BRS has the meaning as follows
*     IRES = 1 : top quark,  IRES = 2 : W-boson, 
*     IRES = 3 : H+- boson,  IRES = 4 : Z-boson 
* mid(0, i) is NIDCmax, i.e. max. number of decay channels
*
      integer IT, I
      double precision wfcnc(0:6) 
      double precision twidnew 
      double precision topwid
*.............. 
      TwidNew = 0.d0   ! decay width due to uncalculated channels
*............................................................................*
* 1 : d W (SM), 2: s W (SM), 3: b W (SM)                                     *
* 5 : b H+-, 6 : b H+- (T*)                                                  *
* 11:16 FCNC couplings, see FCNC_INI                                         *
* 11(12) = U(C) gluon,  13(14) = U(C) gamma,  15(16) = U(C) Z                *
* here we calculate only SM and FCNC decays                                  *
*............................................................................*

      call FCNC_READ       ! read parameters 

      Rpar(30) = TopWid(1, mq(6))    ! SM top quark decay t -> d W 
      Rpar(31) = TopWid(3, mq(6))    ! SM top quark decay t -> s W 
      Rpar(32) = TopWid(5, mq(6))    ! SM top quark decay t -> b W 
      Rpar(34) = Rpar(30) + Rpar(31) + Rpar(32) ! total top quark width

      IT = 1
        call FCNC_INI(wfcnc)    ! initialisation of FCNC

      if(mid(1, it).eq.-1) mid(1, it) = 0  ! SM always contributes to t width
      if(mid(2, it).eq.-1) mid(2, it) = 0  ! SM always contributes to t width
      if(mid(3, it).eq.-1) mid(3, it) = 0  ! SM always contributes to t width
      do I = 0, ndch 
        wid(I, it) = 0.d0
      enddo
       wid(1, IT) = Rpar(30) ! t -> d W
       wid(2, IT) = Rpar(31) ! t -> s W
       wid(3, IT) = Rpar(32) ! t -> b W
* fcnc
      do i = 1,6
         if(MID((10+i), it).ge.0) wid((10+i), it) = wfcnc(i) 
      enddo
      wid(0, it) = TwidNew   ! total top decay width
       do i = 1, MID(0, it)
        if(MID(i, it).ne.-1) wid(0, it) = wid(0, it) + wid(i,it) 
       enddo
      RETURN
      END
