*----------------------------------------------------------------------------*
*.. author : Serge Slabospitsky, date   : 22.06.2006                         *
*.. matrix element squared for t -> b (W*) l2(nu) l1(l+-) decay, including   *
*.. virtual W-boson exchange                                                 *
*.. WITHOUT calculation of the final lepton polarisation                     *
*.. WITH anomalous couplings                                                 *
      subroutine tbwff(iniq, p,k,l1,l2, VES, ps)
*     -------------------------------------------------                      *
      implicit none
      include "txpar.inc" 
      double precision p(5),k(5), l1(5), l2(5), ps(5) 
      double precision scalp, ves, mt, mu, coef 
      double precision PL1,pl2, l1k,L2K, Q2 
      integer J, iniq, kqw, iq 
      double complex fl2(3), fr2(3), hl2(3), hr2(3),
     & Sflhl(3), Aflhl(3), Sfrhr(3), Afrhr(3),
     & Sflhr(3), SfRhL(3), Sflfr(3), Shlhr(3),
     & Aflfr(3), Ahlhr(3)
      double precision NN1(4), NN2(4), WW(4), epsl(5)
      double precision T1, T2, T3 
      double complex   FL,     FR,      HL,    HR,
     &                 XL,     XR,      YL,    YR
      common /ANOMCPL/FL(20), FR(20), HL(20), HR(20), 
     &                XL(20), XR(20), YL(20), YR(20) 
      double complex ei
      data ei/(0.d0, 1.d0)/
      LOGICAL first
      SAVE first, coef
      DATA first /.TRUE./
*
* all couplings correspond to top tWq interaction: 1 -d, 2 - s, 3 - 6
* kqw function tronsform iniq ==> iq
      IF(first) THEN        ! initializing
      first=.FALSE.
       coef = (rpar(26)/dsqrt(2.d0))**4
       coef = coef * 9.d0 / 2.d0

      do J = 1,3
       fl(j) = (1.d0, 0.d0)
       fl2(j) = fl(j) * conjg(fl(j))
       fr2(j) = fr(j) * conjg(fr(j))
       hl2(j) = hl(j) * conjg(hl(j))
       hr2(j) = hr(j) * conjg(hr(j))
        Sflhl(j) = fl(j)*conjg(hl(j)) + hl(j)*conjg(fl(j))
        Aflhl(j) = fl(j)*conjg(hl(j)) - hl(j)*conjg(fl(j))
       Aflhl(j) = ei * Aflhl(j) 
        Sfrhr(j) = fr(j)*conjg(hr(j)) + hr(j)*conjg(fr(j))
        Afrhr(j) = fr(j)*conjg(hr(j)) - hr(j)*conjg(fr(j))
       Afrhr(j) = ei * Afrhr(j) 
*
       Sflhr(j) = fl(j)*conjg(hr(j)) + hr(j)*conjg(fl(j))
       SfRhL(j) = fr(j)*conjg(hl(j)) + hl(j)*conjg(fr(j))

       Sflfr(j) = fl(j)*conjg(fr(j)) + fr(j)*conjg(fl(j))
       Shlhr(j) = hl(j)*conjg(hr(j)) + hl(j)*conjg(hr(j))

         Aflfr(j) = fl(j)*conjg(fr(j)) - fr(j)*conjg(fl(j))
       Aflfr(j) = ei * Aflfr(j) 
         Ahlhr(j) = hl(j)*conjg(hr(j)) - hr(j)*conjg(hl(j))
       Ahlhr(j) = ei * Ahlhr(j) 

      enddo
       ENDIF
**
      iq = kqw(iniq)
      call epsil3(l1, l2, k, epsl)
      call zer5mom(ps,  2*5)
      mt  = p(5)
      mu  = k(5)

      PL1 = scalp(L1, P)
      PL2 = scalp(L2, P)
      L1K = scalp(L1, K)
      L2K = scalp(L2, K)
      Q2 = 2.d0 * scalp(L1, L2) 
**
      T1= fl2(iq)*pl1 + 4.d0*hl2(iq)*q2*pl2 - mt*q2*sflhl(iq)
      T1 = 16.d0 * T1 * l2k

      T2= fr2(iq)*pl2 + 4.d0*hr2(iq)*q2*pl1 - mt*q2*sfrhr(iq)
      T2 = 16.d0 * T2 * l1k

      T3=2.d0*q2*(sflhr(iq)*pl1 + sfrhl(iq)*pl2) 
     & - mt*q2*(sflfr(iq) + 4.d0*q2*shlhr(iq))
      T3 = 8.d0 * T3 * mu
      ves = coef * (T1 + T2 + T3)

      do J = 1,3
       NN1(J) = -mt*l1(j)
       nn2(j) =  mt*l2(j)
       ww(j) = pl1 * l2(j) - pl2 * l1(j)
     
       ps(J) = 16.d0*l2k *
     & (fl2(iq)*nn1(j) + 4.d0*q2*hl2(iq)*nn2(j)
     & - 2.d0*sflhl(iq)*ww(j) + 2.d0*Aflhl(iq)*epsl(j) )
     &
     &       + 16.d0*l1k *
     & (fr2(iq)*nn2(j) + 4.d0*q2*hr2(iq)*nn1(j)
     & - 2.d0*sfrhr(iq)*ww(j) - 2.d0*Afrhr(iq)*epsl(j) )
     &
     &       +  8.d0*mu*
     & (2.d0*q2*(sflhr(iq)*nn1(j) + sfrhl(iq)*nn2(j)) 
     & - (sflfr(iq) + 4.d0*q2*shlhr(iq))*ww(j)
     & + (Aflfr(iq) - 4.d0*Ahlhr(iq))*epsl(j) )

      ps(j) = ps(j) / (T1 + T2 + T3)
*      ps(j) = -ps(j) ! transit to 3-space 
*      ps(j) = ps(j) ! transit to 3-space 
      enddo
      ps(4) = 0.d0
      ps(5) = 0.d0
c      print*,'*****************  '
c      print*,' ps(x y z) ',(ps(j),j=1,3) 
c      print*,' l1/l0     ',( (l1(j)/l1(4)),j=1,3)
      return
      end
