*----------------------------------------------------------------------------*
*  author : Serge Slabospitsky   06.06.2006                                  *
*  FCNC_02 process: g   g   -> g    top                                      *
*     momenta:      p1  p2     p3   p4                                       *
*     spinors:                 DS3  DS4                                      * 
*  for T only, not for Tbar. However, IT = -6 is used for T-polar. evaluation*
* => iq1 should be POSITIVE                                                  *
*  averaged on initial spins and colors                                      *
*............................................................................*

      subroutine tfcnc_02(iq3, idia, p1, p2, p3, p4, ves, hv)
      implicit none
      include "txpar.inc" 
      double precision p1(5), p2(5)       ! momenta of initial quarks
      double precision p3(5), p4(5)       ! momenta of Y and top 
      double precision Ves,coef, hv(4),x3,
     & s,s2,s3,s4, t,t2, t3,t4,ZZ, 
     & mt,mt2,mt4,mt6,mt8,mt10,mt12, 
     & y1, y2, sp(4), vh(3,4), aran,pyr,uu

      LOGICAL first
      SAVE first, coef
      DATA first /.TRUE./
      double complex   FL,     FR,      HL,    HR,
     &                 XL,     XR,      YL,    YR
      common /ANOMCPL/FL(20), FR(20), HL(20), HR(20), 
     &                XL(20), XR(20), YL(20), YR(20) 
      double complex AR, AL, U0(2), UP(2)
      save U0, UP
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
      integer iq3,idia,iqf, j

*............................................................................*
      IF(first) THEN        ! initializing
        coef = rpar(10) ! transformation 1/GeV**2 to mb 
        coef = coef / 4.d0 ! due to lambda_a
*        coef = coef / (2.d0*2.d0 * 8.d0*8.d0) included 
        mt = mq(6)
        mt2 = mt**2
        mt4 = mt**4
        mt6 = mt**6
        mt8 = mt**8
       mt10 = mt**10
       mt12 = mt**12
        iqf = 11
       AR = mt*XR(iqf) - 4.d0*HR(iqf)
       AR = AR * conjg(AR)
       AL = mt*XL(iqf) - 4.d0*HL(iqf)
       AL = AL * conjg(AL)

       U0(1) = AR + AL
       UP(1) = AR - AL
        iqf = 12
       AR = mt*XR(iqf) - 4.d0*HR(iqf)
       AR = AR * conjg(AR)
       AL = mt*XL(iqf) - 4.d0*HL(iqf)
       AL = AL * conjg(AL)

       U0(2) = AR + AL
       UP(2) = AR - AL

       print*,'  Contributed code:   '
       print*,'  Rui Santos and Pedro Ferreira --> '
       print*,'  FCNC top-gluon-quark interaction '
       print*,'                     '
 
       first=.FALSE.
      ENDIF
      ves = 0.d0

        if(abs(iq3).eq.2) iqf = 1
        if(abs(iq3).eq.4) iqf = 2
*
********************

       s = (p1(4) + p2(4))**2 - (p1(1) + p2(1))**2
     &   - (p1(2) + p2(2))**2 - (p1(3) + p2(3))**2
       t = (p1(4) - p4(4))**2 - (p1(1) - p4(1))**2
     &   - (p1(2) - p4(2))**2 - (p1(3) - p4(3))**2
 
       s2 = s**2
       s3 = s**3
       s4 = s**4
       t2 = t**2
       t3 = t**3
       t4 = t**4

      ZZ = s*(mt2 - t)**2*t*(s+t)**2 * (s + t - mt2) 


      X3 =  2.d0*(4.d0*s2 + 9.d0*t*s + 9.d0*t2)* mt12
     &  - 4.d0*(s + 2*t)*(4*s2 + 9*t*s + 9*t2)*mt10
     & + 4*(s + 2*t)*(3*s3 + 14*t*s2 + 27*t2*s
     & + 18*t3)*mt8
     &-(s+t)*(4*s4 + 45*t*s3 + 157*t2*s2
     &+ 270*t3*s + 180*t4)* mt6
     & + t*(s+t)*(19*s4 + 104*t*s3 + 233*t2*s2
     &  + 288*t3*s + 144*t4)*mt4
     &-3*t2*(s+t)**2*(10*s3 + 27*t*s2 + 36*t2*s + 24*t3)*mt2
     &+3.d0*t3*(s+t)**3*(5.d0*s2 + 6.d0*t*s + 6.d0*t2)

      X3 = X3 * U0(iqf) 

      do J = 1,4
       y1 = p1(j)
       y2 = p2(j)

      sp(j) = 
     &- 2.d0*(2.d0*Y1 + Y2)*(4.d0*s2 + 9.d0*t*s + 9.d0*t2)*mt10 
     &+ ( (24.d0*Y1 + 7.d0*Y2)*s3 + (110.d0*Y1+23.d0*Y2)*t*s2 
     &+ 36.d0*(5.d0*Y1+Y2)*t2*s + 18.d0*(7.d0*Y1+2.d0*Y2)*t3)*mt8 
     &- ( 17.d0*Y1*s4 + 3.d0*(40.d0*Y1-3.d0*Y2)*t*s3 
     &   +(317.d0*Y1-19.d0*Y2)*t2*s2 
     &   +396.d0*Y1*t3*s + 18.d0*(11.d0*Y1+Y2)*t4)*mt6 
     &+ (s+t)*(8.d0*Y1*s4 + (68.d0*Y1-21*Y2)*t*s3 
     &   + 4.d0*(53.d0*Y1 - 11.d0*Y2)*t2*s2 
     &  + 18.d0*(17.d0*Y1-2.d0*Y2)*t3*s 
     & + 18.d0*(10.d0*Y1-Y2)*t4)*mt4 
     &- t*(s + t)*( 23.d0*Y1*s4 
     & + (107.d0*Y1-20.d0*Y2)*t*s3 + 15.d0*(14.d0*Y1-3.d0*Y2)*t2*s2 
     & + 54.d0*(4.d0*Y1-Y2)*t3*s + 18.d0*(5.d0*Y1-2.d0*Y2)*t4)*mt2
     &+ 3.d0*t2*
     & (s + t)**2*(s*Y1+(Y1-Y2)*t)*(5.d0*s2+6.d0*t*s+6.d0*t2)

      sp(j) = UP(iqf) * mt * sp(j) / x3 
      enddo

      call vortas(p4, vh)
       do j = 1,3
        hv(j) = -(sp(4)*vh(j,4) - sp(1)*vh(j,1) - sp(2)*vh(j,2) 
     &                            - sp(3)*vh(j,3))
       enddo

      ves = X3 * coef * rpar(16)**2  / 48.d0 / ZZ

      UU = abs(mt2 - s - t)
      idia = 1
      aran = pyr(0)*(abs(t) + UU)
       if(aran.le.uu) then
        idia = 1
       else
        idia = 2
       endif


      if(iq3.gt.0) ves = -ves
*
      if(ves.le.0.d0) then
       print*,'NEGATIVE  ves x3 ',ves,x3
*      else 
*       print*,'positive  ves x3 ',ves,x3
      endif
      return
      end
