c----------------------------------------------------------------------------c
*  author : Serge Slabospitsky   30.05.2006                                  *
*  matrix element for FCNC top production:  2 -> 1                           *
*  g(p1)  U/C(p2) --> t* -> b W* -> b(p3) L+(p5) nu(p4)                      *
*  averaged on initial spins and colors                                      *
*............................................................................*

      subroutine tfcnc_SM(iu, p1, p2, p3, p5, p4, ves)
      implicit none
      include "txpar.inc" 
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
      double precision  p1(5), p2(5)     ! momenta of initial gluon and u-quark
      double precision  p3(5), p5(5), p4(5)   ! momenta of b, L+, nu 
      double precision Ves, coef, ckm 
      integer iu, iqf ! initial quark (u or c)
      integer isu  ! = -1 for q2 < 0
*
      LOGICAL first
      SAVE first, coef
      DATA first /.TRUE./
      double precision VCKM
      common  /CKMD/ VCKM(-6:6,-6:6) ! CKM**2
*......... 
      double precision eg(5),x1(5),x2(5),x3(5)
      double complex ux1, ux2, ux3, veg(4,4),
     & UP2(2,4), UBP3(2,4), WB(4,4), PR1(4,4),PR2(4,4),PR3(4,4),
     & UG1(4,4), ug2(4,4), ug3(4,4), um1(4,4), um2(4,4)
      integer I,ig,i2,i3
*..RPAR(10)     : 0.38939d0     transformation 1/GeV**2 to mb                *
*..RPAR(26)     : g = g_weak  = e / sin(theta_W)                             *
*..Rpar(36)     : M(top) * width(total top)                                  *
*............................................................................*
      IF(first) THEN        ! initializing
       coef = rpar(10) * rpar(26)**4       ! W-exchange
       coef = coef / (3.d0 * 8.d0 * 4.d0) 
       coef = coef * 9.d0     ! 9.d0 is due to sum over leptons and quarks
      first=.FALSE.
      print*,'Vub Vcb ',dsqrt(vckm(2,5)), dsqrt(vckm(4,5))

      ENDIF
       ckm = dsqrt(vckm(iu,5))
        iqf = 0
        if(iu.eq.2) iqf = 1
        if(iu.eq.4) iqf = 2
      do I=1,4
       x1(i) =  p3(i) - p1(i)
       x2(i) =  p1(i) + p2(i)
       x3(i) =  x2(i)
      enddo
       x1(5) = p3(5)
       x2(5) = p2(5)
       x3(5) = mq(6)
       call PropF(x1, PR1)
       call PropF(x2, PR2)
       call PropF2(rpar(36), x3, PR3)

       call VbosMX(p4, p5, WB)

      call Dirs2_Ubar(p3, UBP3)
      call Dirs2_U   (p2, UP2)

*
      ves = 0.d0
      do ig = 1,2
       call VpolGAM(IG, isu,  p1, eg)
       call phat(eg, Veg)
       call prod_2(veg, PR1, UM1)
       call prod_2(UM1, WB, UG1)   ! t1
       call prod_2(PR2, Veg, UM1)
       call prod_2(WB,  UM1, UG2)  ! t2
* t3
       call Q_GLU_T(iqf, x2, p1, eg, UM2)
       call prod_2(WB, PR3, UM1)
       call prod_2(UM1, UM2, UG3) 
*
      do i2 = 1,2
      do i3 = 1,2
        call Ubar_m_U(i3, i2, UBP3, UP2, UG1, UX1)
        call Ubar_m_U(i3, i2, UBP3, UP2, UG2, UX2)
        call Ubar_m_U(i3, i2, UBP3, UP2, UG3, UX3)
        UX1 = ux1 * ckm
        UX2 = ux2 * ckm
       if(Ipar(26).eq.0) then 
          ves = ves + (ux1+ux2+ux3) * conjg(ux1+ux2+ux3)
       elseif(Ipar(26).eq.1) then 
          ves = ves + (ux1+ux2) * conjg(ux1+ux2)
       elseif(Ipar(26).eq.2) then 
          ves = ves + ux3 * conjg(ux3)
       endif
      enddo
      enddo
      enddo
***
 999   ves = ves * coef * rpar(16)  ! * dn3
      if(ves.le.0.d0) then
        print*,'========================'
      endif

      return
      end
