*----------------------------------------------------------------------------*
*.. author : Serge Slabospitsky   10.03.2002                                 *
*.... top decay into b and H+- (-> f1(L1) f2(L2))                            *
* summed over ALL channels (includeing colors for q qbar'                    *
      subroutine THB_dec(gamh, gtot) 
*     ------------------------------                                         *
*                                                                            *
*    LIPS_3 with denominator due to H-boson                                  *
*  all momenta in top rest frame                                             *
*  width is normalized to t -> b tau NU_tau                                  *
*                                                                            *
*    |M|**2     R3(R -> B f f`~)                                             *
*  --------------------------------                                          *
*  [(pH^2 - mH^2)^2 + (G_H * mH)^2]                                          *
*                                                                            *
*     p -> b   H (-> Nu_tau Tau)                                             *
*     R    k   Ph    L1     L2                                               *
*... input :                                                                 *
*   ID = 1,2,...,21 is type of H+- decay channel                             *
*   KF = 6 (-6)  is top flavor                                               *
*    MT is initial top mass,  lepton and neutrino denoted two final fermions *
*    resulted from H-boson decay                                             *
*                                                                            *
*... output :                                                                *
*  Q, L, and N are 5-momenta of final quark, lepton, and neutrino            *
*  in the top REST frame                                                     *
*  ves is the weight                                                         * 
*  DH(3)  is 3-momentum of polarisation vector                               *
*............................................................................*

      implicit none
      include "txpar.inc" 
      double precision P(5), K(5), L1(5), L2(5), ph(5) 
      double precision ves, vs1, axa, scalp, coef
*...........
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
      Integer I, ID, J1, J2, IRES 
      double precision HCPL,       HCPL2   
      common/HPMCPL/   HCPL(-20:20), HCPL2(-20:20)
      double precision aa1, bb1, pmm(2),p2s, gamh, gtot ! , gtbh
      double precision VCKM
      common  /CKMD/ VCKM(-6:6,-6:6) ! CKM**2
      double precision pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common/piconst/  pi, pi2, pi4, pi2_3, pi2_4, pi2_6
* 
       ires = 3  ! H+-
      coef = (pi2_3/2.d0) * rpar(26)**4 
      coef = coef * pi2_6 / 2.d0 / mq(6) 

      aa1 = hcpl2(5) + hcpl2(6)
      bb1 = 2.d0 * hcpl(5)*hcpl(6)*mq(5)*mq(6)
      pmm(1) = rpar(70) + 2.0   ! pmin
      pmm(2) = mq(6) - mq(5)     ! pmax
      gtot = 0.d0
      p(4) = mq(6) 
      p(5) = p(4)
      k(5) = mq(5)
      ID = 0
 222  ID = ID + 1
      IF(ID.GT.mid(0, ires)) goto 112

      if(mid(ID,  ires).eq.-1) goto 115
        J1 = ABS(FID(ires,id,1))
        J2 = ABS(FID(ires,id,2))
        if(j1.eq.6.or.j2.eq.6) goto 115
        L1(5) = mq(J1)
        L2(5) = mq(J2) 
      DO I = 1, Ipar(53)
      call brtwig(pmm, rpar(51), gamh, VS1, p2s)
       VES = VS1
      ph(5)= p2s
      call LIPS2 (p,   k, ph, VS1)
       VES = VES * VS1
      call LIPS2 (ph, l1, l2, VS1)
       VES = VES * VS1
       AXA = (BB1  + AA1 * scalp(p,k)) 
     & * ((hcpl2(J1)+hcpl2(J2)) * scalp(l1,l2)
     &  -2.d0*l1(5)*l2(5)*hcpl(J1)*hcpl(J2))
       VES = VES * coef * AXA 
      if(j1.le.6) ves = ves * 3.d0 * vckm(j1,j2) 
      gtot = gtot + ves 
      ENDDO 
 115  goto 222
 112  gtot = gtot / ipar(53)

      return
      end
