c----------------------------------------------------------------------------c
*.. author : Serge Slabospitsky   25.10.2002                                 *
*....
      subroutine Top_dec_02(id, kf, MT) 
*     ------------------------------                                         *
*                                                                            *
*     R -> q(ib)  W (-> el nu)                                               *
*     P    q   Pw    L  N                                                    *
*... input :                                                                 *
*  KF = 6 (-6)  is top flavor                                                *
*  MT is initial top mass,  L and N stand for two final fermions from W decay*
*... output :                                                                *
* particle's order in decmom list                                            *
*    1:W  2:B, 3:NU(U), 4: L+-(D)                                            *
*  Q, L, and N are 5-momenta of final quark, lepton, and neutrino            *
*  in the top REST frame                                                     *
*............................................................................*

      implicit none
      include "txpar.inc" 
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
      integer mxdc
      parameter (mxdc=20)   
      integer                      ndec, kdec
      double precision pdm, pdpl
      common /decmom/ pdm(mxdc,5), pdpl(mxdc,4), ndec, kdec(mxdc,3)
*...........
      double precision MT,P(5),Q(5),L(5),N(5),pw(5),Ves,  PYR,
     &  vesL,  vesR 
      LOGICAL first
      SAVE first 
      DATA first /.TRUE./
      double precision VesMax(5,2), aran, ps1(5) 
      save VesMax 
      integer I, KF, KV, idc, iz, iq, id, ib, iqq,iqt,j8,j9 
      double precision pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common/piconst/  pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      double precision cos3, nv(3)
      common /nvv/nv
* 
      do j8 = 1,mxdc
       do j9 = 1,3
          pdm(j8,j9) = 0.d0
         pdpl(j8,j9) = 0.d0
         kdec(j8,j9) = 0
       enddo
          pdm(j8,4) = 0.d0
          pdm(j8,5) = 0.d0
         pdpl(j8,4) = 0.d0
      enddo
       ndec = 4
      if(.NOT.first) goto 114 

      do j8 = 1,5
        Vesmax(j8,1) = 0.d0
        Vesmax(j8,2) = 0.d0
      enddo

       P(4) = MT 
       P(5) = P(4)
       l(5) = 0.d0
       n(5) = 0.d0

      do I = 1,  ipar(52)
       do iqt = 1,3
        iqq = 2*iqt - 1
        q(5) = mq(iqq)
        l(5) = 0.d0
        n(5) = 0.d0
        call top_dec_wff(iqq,  p, q, pw, l, n, ps1, ves)
        iz =  kf / abs(kf)  ! +1(-1) for top (topbar) 
         if(ipar(33).eq.2) ves = ves * (1.d0-ps1(3))/2.d0
         if(ipar(33).eq.3) ves = ves * (1.d0+ps1(3))/2.d0
         if(ipar(33).eq.4) then  ! tt~ LL
             vesL = ves * (1.d0-ps1(3))/2.d0
             vesR = vesL 
         elseif(ipar(33).eq.5) then ! tt~ LR
             vesL = ves * (1.d0-ps1(3))/2.d0
             vesR = ves * (1.d0+ps1(3))/2.d0
         elseif(ipar(33).eq.6) then ! tt~ RL
             vesL = ves * (1.d0+ps1(3))/2.d0
             vesR = ves * (1.d0-ps1(3))/2.d0
         elseif(ipar(33).eq.7) then ! ~ tt~ RR
             vesL = ves * (1.d0+ps1(3))/2.d0
             vesR = vesL
         endif

       if(ipar(33).ge.4.AND.ipar(33).le.7) then 
         if(vesL.ge.VesMax(iqq,1)) VesMax(iqq,1) = vesL
         if(vesR.ge.VesMax(iqq,2)) VesMax(iqq,2) = vesR
       else
         if(Ves.gt.VesMax(iqq,1)) VesMax(iqq,1) = Ves 
       endif

       enddo
      enddo
      first = .false. 

 114  continue 
        ib = 2*id - 1       
        iz =  kf / abs(kf)  ! +1(-1) for top (topbar) 
        kv  = iz * 24       ! KF code of W-boson from top 
        iq  = iz * ib       ! for t -> b W(H)
       call Res_branch(2, kv, idc)
       iqq = abs(iq)
       Q(5) = mq(iqq) 
       N(5) = mq(ABS(FID(2, IDC, 1))) 
       L(5) = mq(ABS(FID(2, IDC, 2))) 

       call zer5mom(p) 
      P(4) = MT 
      P(5) = P(4)
 115   call top_dec_wff(iqq,  p, q, pw, l, n, ps1, ves)
    
        cos3 = 
     & nv(1)*ps1(1) + nv(2)*ps1(2) + nv(3)*ps1(3)
        if(ipar(33).eq.2) ves = ves*(1.d0 - cos3) / 2.d0 
        if(ipar(33).eq.3) ves = ves*(1.d0 + cos3) / 2.d0 
         if(ipar(33).eq.4) then       ! tt~ LL
             vesL = ves * (1.d0 - cos3)/2.d0
             vesR = vesL 
         elseif(ipar(33).eq.5) then  ! tt~ LR
             vesL = ves * (1.d0 - cos3)/2.d0
             vesR = ves * (1.d0 + cos3)/2.d0
         elseif(ipar(33).eq.6) then  ! tt~ RL
             vesL = ves * (1.d0 + cos3)/2.d0
             vesR = ves * (1.d0 - cos3)/2.d0
         elseif(ipar(33).eq.7) then ! tt~ RR
             vesL = ves * (1.d0 + cos3)/2.d0
             vesR = vesL
         endif

      If(ipar(33).ge.4.AND.ipar(33).le.7) then 
        if(iz.gt.0) then   
         if(vesL.ge.VesMax(iqq,1)) VesMax(iqq,1) = vesL
         ves = vesL
         aran = VesMax(iqq,1) * PYR(0) 
        else 
         if(vesR.ge.VesMax(iqq,2)) VesMax(iqq,2) = vesR
         ves = vesR
         aran = VesMax(iqq,2) * PYR(0) 
        endif
      Else 
         if(Ves.gt.VesMax(iqq,1)) VesMax(iqq,1) = Ves 
         aran = VesMax(iqq,1) * PYR(0) 
      EndIf 

       if(Ves.lt.aran) goto 115 
**
       kdec(1,1) = KV                  ! W-boson
       kdec(2,1) = IQ                  ! Q-quark from t -> Q W
       kdec(3,1) = iz * FID(2, IDC, 1) ! NU
       kdec(4,1) = iz * FID(2, IDC, 2) ! L 

      do I = 1,5
       pdm(1,I) = PW(I) 
       pdm(2,I) = Q(i)
       pdm(3,I) = N(i)
       pdm(4,I) = L(i)
       pdm(20,I) = IZ*ps1(I) ! top polarization vector in top rest frame
      enddo
      return
      end
