c----------------------------------------------------------------------------c
*.. author : Serge Slabospitsky   14.12.2000                                 *
*.... top decay in to b and H+- (-> Nu(L1) L+-(L2))                          *
      subroutine Top_dec_03(kf, MT) 
*     ------------------------------------------                             *
*                                                                            *
*    LIPS_3 with denominator due to H-boson                                  *
*  all momenta in top rest frame                                             *
*  width is normalized to t -> b tau NU_tau                                  *
*                                                                            *
*    |M|**2     R3(R -> B f f`~)                                             *
*  --------------------------------                                          *
*  [(pH^2 - mH^2)^2 + (G_H * mH)^2]                                          *
*                                                                            *
*     R -> b   H (-> Nu_tau Tau)                                             *
*     R    k   Ph    L1     L2                                               *
*... input :                                                                 *
*   ID = 1,2,...,21 is type of H+- decay channel                             *
*   KF = 6 (-6)  is top flavor                                               *
*    MT is initial top mass,  lepton and neutrino denoted two final fermions *
*    resulted from H-boson decay                                             *
*    arbirary normalization                                                  *
*... output :                                                                *
*  Q, L, and N are 5-momenta of final quark, lepton, and neutrino            *
*  in the top REST frame                                                     *
*  ves is the weight                                                         * 
*  DH(3)  is 3-momentum of polarisation vector                               *
*............................................................................*

      implicit none
      include "txpar.inc" 
      double precision MT
      double precision P(5), K(5), L1(5), L2(5), ph(5) 
      double precision Ves, Vs1, PYR
      LOGICAL first
      SAVE first 
      DATA first /.TRUE./
      double precision VesMaX(30), aran, scalp 
      save VesMaX 
      integer ires
      save ires
*...........
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
      integer mxdc
      parameter (mxdc=20)   
      integer ndec, kdec
      double precision pdm, pdpl
      common /decmom/ pdm(mxdc,5), pdpl(mxdc,4), ndec, kdec(mxdc,3)
      integer II, KF, IDH, J1, J2, IZ, KV, IQ,j8,j9  
      double precision HCPL,       HCPL2   
      common/HPMCPL/   HCPL(-20:20), HCPL2(-20:20)
      double precision aa1,aa2, bb1, pmm(2), p2s, AXA, AXB 
      save aa1, aa2, bb1
* 
      do j8 = 1,mxdc
       do j9 = 1,3
          pdm(j8,j9) = 0.d0
         kdec(j8,j9) = 0
       enddo
          pdm(j8,4) = 0.d0
          pdm(j8,5) = 0.d0
      enddo
      ndec = 4

      pmm(1) = rpar(70) + 2.0   ! pmin
      pmm(2) = MT -  mq(5)       ! pmax
       call zer5mom(p) 
      p(4) = MT 
      p(5) = p(4)
      k(5) = mq(5)
      ires = 3
*...
      if(.NOT.first) goto 114 
      if(ipar(33).ge.2) then
       print*,'********************************************'
       print*,'*  IPAR(33) value = ',ipar(33)
       print*,'*  is implemented for t -> b H+-           *'
       print*,'********************************************'
      endif 

      aa1 = hcpl2(5) + hcpl2(6)
      aa2 = 2.d0 * hcpl(5)*hcpl(6)*mq(5)*MT 
      bb1 = hcpl2(6) - hcpl2(5)

      do j8 = 1,30
        vesmax(j8) = 0.d0
      enddo
*
      do 115 IDH = 1,mid(0, 2) 
       if(mid(idh, ires).le.-1)    goto 115
       J1 = ABS(FID(ires,idh,1))
       J2 = ABS(FID(ires,idh,2))
       if(j1.eq.6.or.j2.eq.6) goto 115
       L1(5) = mq(J1)
       L2(5) = mq(J2) 

      do ii = 1, ipar(52)
      call brtwig(pmm, rpar(51), rpar(54), VS1, p2s)
       VES = VS1
      ph(5)= p2s
      call LIPS2 (p,   k, ph, VS1)
       VES = VES * VS1
      call LIPS2 (ph, l1, l2, VS1)
       VES = VES * VS1
       AXA = (AA1 * scalp(p,k) + AA2) 
       AXB = (hcpl2(J1)+hcpl2(J2)) * scalp(l1,l2)
     &  -2.d0*l1(5)*l2(5)*hcpl(J1)*hcpl2(J2)
       VES = VES * AXA * AXB
       if(Ves.gt.VesMax(idh)) VesMax(idh) = Ves 
      enddo
 115  continue
      first = .false. 

 114  continue
        iz =  kf / abs(kf)  ! +1(-1) for top (topbar) 
        kv  = iz * 37       ! KF code of H-boson from top 
        iq  = iz *  5       ! for t -> b W(H)
 116   call Res_branch(ires, kv, idh)
       J1 = ABS(FID(ires,idh,1))
       J2 = ABS(FID(ires,idh,2))
       if(j1.eq.6.or.j2.eq.6) goto 116
       L1(5) = mq(J1)
       L2(5) = mq(J2) 
      call brtwig(pmm, rpar(51), rpar(54), VS1, p2s)
       VES = VS1
      ph(5)= p2s
      call LIPS2 (p,   k, ph, VS1)
       VES = VES * VS1
      call LIPS2 (ph, l1, l2, VS1)
       VES = VES * VS1
       AXA = (BB1 * MT + AA1 * scalp(p,k)) 
       AXB = (hcpl2(J1)+hcpl2(J2)) * scalp(l1,l2)
     &  -2.d0*l1(5)*l2(5)*hcpl(J1)*hcpl2(J2)
       VES = VES * AXA * AXB
       if(Ves.gt.VesMax(idh)) VesMax(idh) = Ves 
       aran = VesMax(idh) * PYR(0) 
       if(Ves.lt.aran) goto 116 


       kdec(1,1) = KV                ! H-boson
       kdec(2,1) = IQ                ! B-quark
       kdec(3,1) = iz * FID(ires, IDH, 1) ! NU
       kdec(4,1) = iz * FID(ires, IDH, 2) ! L+- 
*       kdec(4,3) = +10  ! will be used in TAUOLA

      do II = 1,5
       pdm(1,II) = PH(II) 
       pdm(2,II) = K(II)
       pdm(3,II) = L1(II)
       pdm(4,II) = L2(II)
       pdm(20,II) = MT*BB1*K(II) / AXA 
        if(kf.eq.-6) pdm(20,II) = -pdm(20,II) 
      enddo
      return
      end
