c----------------------------------------------------------------------------c
*.. author : Serge Slabospitsky   22.05.2006                                 *
*                                                                            *
      subroutine Top_dec_04(id, kf, MT) 
*     --------------------------------------------                           *
* FCNC top quark decay into u(c)-quark and Z (-> L- L+), L+- = e, mu, tau    *
*                                                                            *
*    LIPS_3 with denominator due to Z-boson                                  *
*  all momenta in top rest frame                                             *
*  width is normalized to t -> q Z( -> L- L+)                                *
*                                                                            *
*     |M|^2   R3(R -> Q L1 L2)                                               *
*  --------------------------------                                          *
*  [(pZ^2 - mZ^2)^2 + (G_Z * mZ)^2]                                          *
*                                                                            *
*     R -> Q   Z (-> L- L+)                                                  *
*     R    q   Pw    L1 L2                                                   *
*... input :                                                                 *
*   KF = 6 (-6)  is top flavor                                               *
*    MT is initial top mass                                                  *
*  id is Z-boson decay channel                                               *
*                                                                            *
*... output :                                                                *
*  Q, L1, and L2 are 5-momenta of final quark, L+ and L- and L+              *
*  in the top REST frame                                                     *
*  ves is the weight                                                         * 
*  DH(3)  is 3-momentum of polarisation vector                               *
*............................................................................*

      implicit none
      include "txpar.inc" 
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
      integer mxdc
      parameter (mxdc=20)   
      integer ndec, kdec
      double precision pdm, pdpl
      common /decmom/ pdm(mxdc,5), pdpl(mxdc,4), ndec, kdec(mxdc,3)
*...........
      double precision MT, R(5), K(5), L1(5), L2(5) 
      double precision hh(5) 
      double precision Ves,  PYR 
      LOGICAL first
      SAVE first 
      DATA first /.TRUE./
      double precision aran, u0
      double precision vesmax(2,16) 
      double precision vestot(2,16) 
      save VesMax
      integer JQ, JL, JD,j8,j9 
      integer I, KF, id, idz, ires, KV, iq, j1, j2
*
      R(4) = MT 
      R(5) = R(4)
      ndec = 4
      ires = 4
      do j8 = 1,mxdc
       do j9 = 1,5
          pdm(j8,j9) = 0.d0
       enddo
      enddo 
*
      if(first) then
      if(ipar(33).ge.2) then
       print*,'********************************************'
       print*,'*  IPAR(33) value = ',ipar(33) 
       print*,'*  is implemented for t -> u(c) Z          *'
       print*,'********************************************'
      endif 
      endif

      if(.NOT.first) goto 114 

      do j8 = 1,2
       do j9 = 1,16
        vestot(j8,j9) = 0.d0
       enddo
      enddo

       do JQ = 1,2 
        if(jq.eq.1) then 
          iq = 2  ! UP
          jd = 15
        elseif(jq.eq.2) then
          iq = 4  ! charm 
          jd = 16
        endif 
       do JL = 1,16 
        VesMax(jq, jl) = 0.d0
        if(jl.eq.6.or.jl.eq.7.or.jl.eq.8) goto 222
        j1 = fid(4,jl,1)
         DO I = 1, ipar(52)
          k(5)  = mq(iq)
          l1(5) = mq(j1) 
          l2(5) = mq(j1) 

      call Rlip44(R, l1, l2, k, ves)
      call top_dec_qZ(jd, iq, j1, R, k, l1, l2, U0, hh)
       Ves = VES * U0 
       vestot(jq,jl) = vestot(jq,jl) + VES
       if(Ves.gt.VesMax(jq,jl)) VesMax(jq,jl) = Ves 
      ENDDO
 222  continue
      enddo
      enddo

       do JQ = 1,2 
        ves = 0.d0
       do JL = 1,16 
       vestot(jq,jl) = vestot(jq,jl) / ipar(52)
        print*,' Q L ves ',jq,jl,vestot(jq,jl)
        ves = ves + vestot(jq,jl)
       enddo
        print*,' Q gam ',jq,ves
       enddo
***
      first = .false. 

 114  continue
        kv  = 23                          ! KF code of Z-boson from top 
        iq  = FID(1,id,1) * kf / abs(kf)  ! for t -> q Z
        if(iq.eq.2) jd = 15
        if(iq.eq.4) jd = 16
 116   call Res_branch(ires, kv, idz)
       J1 = ABS(FID(ires,idz,1))
       J2 = ABS(FID(ires,idz,2))
       L1(5) = mq(J1)
       L2(5) = mq(J2) 
       k(5) = mq(abs(iq))
      call Rlip44(R, l1, l2, k, ves)
      call top_dec_qZ(jd, iq, J1, R, k, l1, l2, U0, hh)
       Ves = VES * U0 
       if(Ves.gt.VesMax((jd-14),idz)) VesMax((jd-14),idz) = Ves 
        aran = VesMax((jd-14),idz) * PYR(0) 
       if(Ves.lt.aran) goto 116

       kdec(1,1) = KV                ! H-boson
       kdec(2,1) = IQ                ! B-quark
       kdec(3,1) = FID(ires, IDZ, 1) ! L- 
       kdec(4,1) = FID(ires, IDZ, 2) ! L+

      do I = 1,5
       pdm(1,I) = L1(i) +  L2(i)
       pdm(2,I) = k(i)
       pdm(3,I) = L1(i)
       pdm(4,I) = L2(i)
       pdm(20,I) = hh(I) 
        if(kf.eq.-6) pdm(20,I) = -pdm(20,I) 
      enddo
       pdm(1,5) = dsqrt(pdm(1,4)**2 - pdm(1,1)**2
     &                - pdm(1,2)**2 - pdm(1,3)**2)
      return
      end
