*----------------------------------------------------------------------------*
*..decays routines. for PYTHIA 6.2xx version                                 *
*.. author : Serge Slabospitsky   27.01.2001                                 *
*....                                                                        *
       subroutine top_rdec_1(id, KP)
*     ---------------------------------                                      *
*  ID is  top decay channel                                                  *
*  KP is the position of t-quark in HEPEUP list                              *
*  KFT is the KF code  of t-quark                                            *
*............................................................................*

      implicit none
* PYTHIA6.2 common block for external user's process 

      include "hepeup.inc"
      include "txpar.inc" 
      integer id, KP, KFT, Irs, I
      double precision vh, pyr, ves
      common /topol1/ vh(4)
      integer mxdc
      parameter (mxdc=20)   
      integer                                     ndec, kdec
      double precision pdm,       pdpl
      common /decmom/  pdm(mxdc,5), pdpl(mxdc,4), ndec, kdec(mxdc,3)
      double precision mt
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
      double precision cos3, nv(3)
      common /nvv/nv
* first parameter in MID, BRF, FID, and BRS has the meaning as follows
*     IRS = 1 : top quark,  IRS = 2 : W-boson, 
*     IRS = 3 : H+- boson,  IRS = 4 : Z-boson 
*     IRS = 5 : t -> b H* -> T* 
*...........
      ndec = 0
      kft = IDup(kp)  ! top KF code of the top quark
      if(kft.lt.0) then
       do i = 1,3
        vh(i) = -vh(i)
       enddo
      endif 

      if( id.eq.1. OR.id.eq.2
     &.OR.id.eq.3)               irs = 2 ! W-boson
      if( id.eq.5)               irs = 3 ! H-boson
      if( id.eq.6)               irs = 5 ! t -> H+- T* 
      if (id.eq.11.or.id.eq.12
     &.or.id.eq.13.or.id.eq.14)  irs = 1 ! t -> q G (A) 
      if( id.eq.15.or.id.eq.16
     &.or.id.eq.17.or.id.eq.18)  irs = 4 ! t -> q Z 
      if(irs.eq.-1) STOP
*
      nv(1) = 0.d0
      nv(2) = 0.d0
      nv(3) = 0.d0
       cos3 = 
     & dsqrt(pup(1,kp)**2+pup(2,kp)**2+pup(3,kp)**2)
       if(cos3.ge.0.001d0) then
        nv(1) = pup(1,kp) / cos3
        nv(2) = pup(2,kp) / cos3
        nv(3) = pup(3,kp) / cos3
       endif 
 11   continue
      mt = pup(5,kp)

       if(irs.eq.1) call Top_dec_01(id, kft, MT) 
       if(irs.eq.2) call Top_dec_02(id, kft, MT) 
       if(irs.eq.3) call Top_dec_03(kft, MT) 
       if(irs.eq.4) call Top_dec_04(id, kft, MT) 
       if(irs.eq.5) call Top_dec_05(kft, MT) 

*      print*,(pup(ii,kp),ii=1,5)
      IF(ipar(33).eq.1) THEN ! take into account spin of produced tops
       ves = vh(1)*pdm(20,1)+vh(2)*pdm(20,2)+vh(3)*pdm(20,3) 
       ves = (1.d0 + ves) / 2.d0
       if(pyr(0).ge.ves) goto 11
      ENDIF

*  final f1 f2~ KF codes 
      if(irs.eq.1)                             then
        call colorf_t_qv(kp) 
      elseif(irs.eq.2.or.irs.eq.3.or.irs.eq.4) then
       call colorf_t_q2f(kp) 
      elseif(irs.eq.5)                         then
       call colorf_t_qht(kp) 
      endif

      return 
      end
