c----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  16.12.2003                                  *
      function TopMV(tw, mt0)
*                                                                            * 
*  calculate the current top mass according Breit-Wigner distribution        *
*         1/((M_t**2 - Mt_0**2)**2 + Width(t)**2 * Mt_0**2)                  *
*... Input  :                                                                *
*  M = M_0 +- ND*width(TOP)                                                  *
*  tw  is total top quark width at the pole mass                             *
*  mt0 is the top pole mass                                                  *
*... Output :                                                                *
*  top current mass                                                          *
*............................................................................*

      implicit None
      double precision topmv, mt0, tw, PYR, nd, mu, md, t0, del, mt2
      data nd/20.d0/
      include "txpar.inc" 
*
      LOGICAL first
      DATA first /.TRUE./
      SAVE first, mt2, t0, del, nd, mu,md 
*
      if(first) THEN
       mt2 = mt0**2
       mu = mt0 + tw*nd 
       md = mt0 - tw*nd
        if(md.lt.(mt0 - mt0/5.d0)) then
          nd =  mt0/5.d0/tw
          mu = mt0 + tw*nd 
          md = mt0 - tw*nd
        endif 
      t0  = datan((md**2 - mt2) / tw / mt0)      
      del = datan((mu**2 - mt2) / tw / mt0) - t0 
      first=.FALSE.
      ENDIF
*
      if(ipar(31).eq.0) then
        topmv = mt0
        return
      endif 
 11   topmv = dsqrt(mt2 + tw*mt0 * dtan(t0 + del*PYR(0)) )
       if(topmv.lt.md.OR.topmv.gt.mu) goto 11 
       rpar(37) = topmv
      return
      end
