*----------------------------------------------------------------------------*
*  initialisation decay routines                                             *
*... author  :  Serge Slabospitsky    02.02.2002                             *
      subroutine TXDEC_INI
*...
      implicit none 
      include "txpar.inc" 
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
*
      integer IT        
* first parameter in MID, BRF, FID, and BRS has the meaning as follows
*     IT = 1 : top quark,  IT = 2 : W-boson, 
*     IT = 3 : H+- boson,  IT = 4 : Z-boson 
*......................
*... copy W-boson decay table from PYTHIA to TopReX
      IT = 2
      if(ipar(1).eq.24) goto 2237
      call W_dec_ini
*... copy Z-boson decay table from PYTHIA to TopReX
      if(ipar(1).eq.5.or.             ! W QQbar
     &   ipar(1).eq.6.or.             ! W -> tau nu 
     &   ipar(1).eq.7.or.             ! jet + W -> tau nu 
     &   ipar(1).eq.9.or.             ! H+- -> tau nu 
     &   ipar(1).eq.10.or.            ! jet + H+- -> tau nu 
     &   ipar(1).eq.61)               ! q qbar -> H+ H-    
     &   goto 2238

 2237 continue
      IT = 5
      if(Ipar(1).eq.24) then  ! H0
         call H0_dec_ini
      endif
*
      IT = 4
      if(Ipar(1).eq.23.or.Ipar(1).eq.24) then  ! final Z
         call Z_dec_ini
         goto 2238
      endif
      if(MID(15, 1).eq.-1.and.MID(16, 1).eq.-1.and
     &  .MID(17, 1).eq.-1.and.MID(18, 1).eq.-1) goto 2238
       call Z_dec_ini
 2238 continue

      if(ipar(1).eq.5.or.ipar(1).eq.23.or.
     &   ipar(1).eq.24) goto 2239
        call T_dec_ini       !  set top quark decay parameters
        call HC_dec_ini      !  set charged Higgs parameters  
        call THC_dec_ini     ! calculate BR for top and H+-     
 2239  continue

 
      return
      end
