*----------------------------------------------------------------------------*
* V^mu = SpinorString * GAMMA^mu(gamma^5) * SpinonColumn 
* GV = gamma^nu * V^nu
* cg = e(f) / Q^2(photon)
* cv(ca) = gv(ga) / (Q^2(Z-boson) - MZ^2 + ei*MZ*Gamma(Z)) 
      subroutine Us_ZbA_Uc(PZ, cg, cv, ca, X, Y, Gf, Gz) 
*     -------------------------------------------                            *
      implicit none
      include "txpar.inc"
      double complex X(2,4), Y(2,4)
      double complex cg, cv, ca
      double complex VP, VM, V1, V2, AP, AM, A1, A2
      double complex Gf(2,2,4), Gz(2,2,4)
      double complex zP, zM, z1, z2, SPV, SPA
      double precision PZ(5) 
      double complex ei 
      data ei/(0.d0, 1.d0)/
      integer I, J, k
*
       do i = 1,2
        do j = 1,2
         do k = 1,4 
          gf(i,j,k) = (0.d0, 0.d0)
          gz(i,j,k) = (0.d0, 0.d0)
         enddo
        enddo
       enddo
*
       zP = pz(4) + pz(3)
       zM = pz(4) - pz(3)
       z1 = pz(1) + ei*pz(2)
       z2 = pz(1) - ei*pz(2)

      do I = 1,2
      do j = 1,2    
       VP = 2.d0 * (X(i,3)*Y(j,1) + X(i,2)*Y(j,4))
       VM = 2.d0 * (X(i,4)*Y(j,2) + X(i,1)*Y(j,3)) 
       V1 = 2.d0 * (X(i,3)*Y(j,2) - X(i,1)*Y(j,4))
       V2 = 2.d0 * (X(i,4)*Y(j,1) - X(i,2)*Y(j,3))

       AP = 2.d0 * (X(i,3)*Y(j,1) - X(i,2)*Y(j,4))
       AM = 2.d0 * (X(i,4)*Y(j,2) - X(i,1)*Y(j,3)) 
       A1 = 2.d0 * (X(i,3)*Y(j,2) + X(i,1)*Y(j,4))
       A2 = 2.d0 * (X(i,4)*Y(j,1) + X(i,2)*Y(j,3))
*
      SPV = 0.5d0 * (vP*zM + vM*zP - v1*z2 - v2*z1)/Rpar(46)
      SPA = 0.5d0 * (aP*zM + aM*zP - a1*z2 - a2*z1)/Rpar(46)

       vP = vP - SPV * zP
       vM = vM - SPV * zM
       v1 = v1 - SPV * z1
       v2 = v2 - SPV * z2

       aP = aP - SPA * zP
       aM = aM - SPA * zM
       a1 = a1 - SPA * z1
       a2 = a2 - SPA * z2

        Gf(I,J,4) = cg * vP
        Gf(I,J,3) = cg * vM
        Gf(I,J,1) = cg * v1
        Gf(I,J,2) = cg * v2

        Gz(I,J,4) = cv * vP + ca * aP
        Gz(I,J,3) = cv * vM + ca * aM
        Gz(I,J,1) = cv * v1 + ca * a1
        Gz(I,J,2) = cv * v2 + ca * a2
      enddo
      enddo
      RETURN
      END
