*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  30.05.2006                                  *
* Photon Polarization vectors                                                *
* output: ev(mu) - polarization vector                                       *
* WARNING: sum on third vectors has                                          *
* for IP = 1 and 2 : return IS = +1                                          *
* for IP = 3 : sign PLUS  for q2 > 0 ==> return IS = +1                      *
*              sign MINUS for q2 < 0 ==> return IS = -1                      *
* q(5) is evaluated here                                                     *
*............................................................................*
      subroutine VpolGAM(IP, IS,  q, V)
      implicit None
      double precision q(5), v(5), pt, qt, qn, q2
      integer IP, IS 
      double precision deps ! minimal value 
      data deps /0.0000001d0/ ! e-7
*
      call zer5mom(v)
      IS = +1
      If(    IP.eq.1) then
        if(pt(q).le.deps) then
          v(1) = 1.d0
        else 
          qt = pt(q)
          v(1) =  q(2) / qt
          v(2) = -q(1) / qt
        endif
      ElseIf(IP.eq.2) then
        if(pt(q).le.deps) then
          v(2) = 1.d0
        else
          qt = pt(q)
          qn = qt * dsqrt(qt*qt + q(3)**2)
          v(1) =  q(1)*q(3) / qn
          v(2) =  q(2)*q(3) / qn
          v(3) = -qt*qt     / qn
        endif
      ElseIf(IP.eq.3) then
          qt = dsqrt(q(1)**2 + q(2)**2) 
          qn = dsqrt(qt*qt + q(3)**2)
          q2 = q(4)**2 - qn**2
           if(q2.le.0.d0) IS = -1
         if(dabs(q2).le.deps) return 
          q2 = dsqrt(dabs(q2))
        if(qn.le.deps) then
          v(3) = 1.d0
        elseif(qt.le.deps) then
          v(4) = q(3) / q2
          v(3) = q(4) / q2
        else
          v(1) = q(4) * q(1) / qn / q2
          v(2) = q(4) * q(2) / qn / q2
          v(3) = q(4) * q(3) / qn / q2
          v(4) =        qn   / q2
        endif
      EndIf        
      return
      end 
