*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  30.05.2006                                  *
* Gluon Polarization vectors                                                 *
* q - gluon 4-vector, N - gauge fixing vector                                *
* output: ev(mu) - polarization vector                                       *
* WARNING: sum on third vectors has                                          *
* for IP = 1 and 2 : return IS = +1                                          *
* for IP = 3 : sign PLUS  for k2 > 0 ==> return IS = +1                      *
*              sign MINUS for k2 < 0 ==> return IS = -1                      *
*  k(5) = k2 is evaluated here                                               *
*............................................................................*
      subroutine VpolGLU(IP, IS, k, n, EV)
      implicit None
      double precision k(5), v(5), EV(5),n(5),pt, kt, kn, k2, scalp, ek
      integer IP, IS, J
      double precision deps ! minimal value 
      data deps /0.0000001d0/ !  e-7
*
      IS = +1
      call zer5mom(v,2*5)
      If(    IP.eq.1) then
        if(pt(k).le.deps) then
          v(1) = 1.d0
        else 
          kt = pt(k)
          v(1) =  k(2) / kt
          v(2) = -k(1) / kt
        endif
      ElseIf(IP.eq.2) then
        if(pt(k).le.deps) then
          v(2) = 1.d0
        else
          kt = pt(k)
          kn = kt * dsqrt(kt*kt + k(3)**2)
          v(1) =  k(1)*k(3) / kn
          v(2) =  k(2)*k(3) / kn
          v(3) = -kt*kt     / kn
        endif
      ElseIf(IP.eq.3) then
          kt = dsqrt(k(1)**2 + k(2)**2) 
          kn = dsqrt(kt*kt + k(3)**2)
          k2 = k(4)**2 - kn**2
           if(k2.le.0.d0) IS = -1
         if(dabs(k2).le.deps) return 
          k2 = dsqrt(dabs(k2))
        if(kn.le.deps) then
          v(3) = 1.d0
        elseif(kt.le.deps) then
          v(4) = k(3) / k2
          v(3) = k(4) / k2
        else
          v(1) = k(4) * k(1) / kn / k2
          v(2) = k(4) * k(2) / kn / k2
          v(3) = k(4) * k(3) / kn / k2
          v(4) =        kn   / k2
        endif
      EndIf
        call zer5mom(ev,2*5)
        ek = scalp(k, n)
       if(dabs(ek).le.deps) then
        print*,' scalar product (QN) is very small'
        print*,' polarization vector equals zero'        
        return
       endif
        ek = scalp(v, n) / ek
        do j = 1,4
         ev(j) = v(j) - ek * k(j)
        enddo
      return
      end 
