c----------------------------------------------------------------------------c
*.. author:  Serge Slabospitsky  15.02.2001                                  *
      Subroutine X1X2DELF(PAR, WR, X1, X2, Wht, q1, q2, Q)
*     ---------------------------------------------------                    *
*  MC generation of the parton's fractions X1, X2 and corresponding momenta  *
*       d X1   d X2                                                          *
*       ----   ----  delta(S x1 x2 - M2)                                     *
*         X1     X2                                                          *
*   M2 will generate with Breit-Wigner shape                                 *
*... Input  :                                                                *
*  PAR(1) = sqrt(Shat_min),          PAR(2) = sqrt(Shat_max)                 *
*  PAR(3) = sqrt(S)  is total initial hadron's energy                        *
*  WR(1)  = mass of the resonance,   WR(2) = width(R) * WR(1)                *
*... Output :                                                                *
*  X1, X2 and q1(5) and q2(5)                                                *
*  WHT is the weight                                                         *
*............................................................................*
      Implicit None
      include "txpar.inc" 
      double precision par(3), WR(2), pmm(2), vs1, p2s
      double precision tau, S, PYR 
      double precision x1, x2, wht, q1(5), q2(5), Q(5), pq1(5)
*      
       wht = 0.d0

      pmm(1) = par(1)
      pmm(2) = par(2)
       call brtwig_2(pmm, WR(1), WR(2), VS1, p2s)

      S = par(3) * par(3)

      tau = p2s**2/S
       x1 = (tau)**PYR(0) 
       x2 = tau / x1
        Rpar(7) = x1
        Rpar(8) = x2
       Wht = -DLOG(tau) / p2s**2
**
      Q(5) = p2s
      Q(4) = (x1 + x2)*par(3) / 2.d0
      Q(3) = (x1 - x2)*par(3) / 2.d0
      Q(2) = 0.d0
      Q(1) = 0.d0
       pq1(4) = (s*tau + q1(5)**2 - q2(5)**2) / 2.d0 / Q(5)
       pq1(3) = dsqrt(pq1(4)**2 - q1(5)**2) 
       pq1(5) = q1(5)
* now PP is momentum of 1-particle in the rest frame of Q 
      call lorenb_s(Q, pq1, q1) ! Lorentz transformation into initial frame
       q1(1) = 0.d0
       q1(2) = 0.d0
       q2(4) = Q(4) - q1(4)
       q2(3) = Q(3) - q1(3)
       q2(1) = 0.d0
       q2(2) = 0.d0
       return
      end
