*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  15.02.2001                                  *
      Subroutine X1X2GEN2(PAR, X1, X2, Wht)
*     -------------------------------------
*  MC generation of the parton's fractions X1, X2 and corresponding momenta  *
*       d X1   d X2                                                          *
*       ----   ----                                                          *
*         X1     X2                                                          *
*                                                                            *
*... Input  :                                                                *
*  PAR(1) and PAR(2) are the minimal and maximal values of the sqrt(S_hat)   *
*  PAR(3) = sqrt(S)  is total initial hadron's energy, i.e. sqrt(S)          *
*... Output :                                                                *
*  X1, X2 and q1(5) and q2(5)                                                *
*  WHT is the weight                                                         *
*............................................................................*
      Implicit None
      include "txpar.inc" 
      double precision x1, x2, wht, par(3), YT0, tau, PYR
      double precision q1(5), q2(5), Q(5) 
      common /txkin/q1, q2, Q
      save /txkin/
      integer I
*      
       wht = 0.d0
       if(par(2).gt.par(3)) return
       YT0 = (  par(2)/par(1))**2                ! shat_max/shat_min  
       tau = ( (par(1)/par(3))**2) * YT0**PYR(0) ! shat_max/ S
       x1 = tau**PYR(0) 
       x2 = tau / x1
       Wht = DLOG(YT0) * (-DLOG(tau))
      call zer5mom(q1) 
      call zer5mom(q2) 
      q1(4) =  0.5 * PAR(3) * x1
      q1(3) =  q1(4)
       q2(4) =  0.5 * PAR(3) * x2
       q2(3) = -q2(4)
        do I = 1,4
         Q(I) = q1(I) + q2(I)
        end do
      Q(5) = Par(3) * dsqrt(x1 * x2)
      Rpar(74) = Q(5)     ! sqrt(Shat)
      Rpar(71) = Q(5)**2  ! Shat
      Rpar(7) = x1
      Rpar(8) = x2
      return
      end
