c----------------------------------------------------------------------------c
*.. author:  Serge Slabospitsky  15.02.2001                                  *
      Subroutine X1X2RES(PAR, WR, X1, X2, Wht, q1, q2, Q)
*     ---------------------------------------------------                    *
*  MC generation of the parton's fractions X1, X2 and corresponding momenta  *
*       d X1   d X2                                                          *
*       ----   ----  ---------------------------                             *
*         X1     X2  [(P**2 - MR**2)**2 + g1**2]                             *
*                                                                            *
*... Input  :                                                                *
*  PAR(1) = sqrt(Shat_min),          PAR(2) = sqrt(Shat_max)                 *
*  PAR(3) = sqrt(S)  is total initial hadron's energy                        *
*  WR(1)  = mass of the resonance,   WR(2) = width(R) * WR(1)                *
*... Output :                                                                *
*  X1, X2 and q1(5) and q2(5)                                                *
*  WHT is the weight                                                         *
*............................................................................*
      Implicit None
      include "txpar.inc" 
      double precision par(3), WR(2)
      double precision t0, d1, tau, S, PYR, zn
      double precision x1, x2, wht, q1(5), q2(5), Q(5), pq1(5)
*      
       wht = 0.d0
       if(par(2).gt.par(3)) return
      S = par(3) * par(3)

      t0 = atan((Par(1)**2 - WR(1)**2)/WR(2))
      D1 = atan((Par(2)**2 - WR(1)**2)/WR(2)) - t0
      tau = (WR(1)**2 + WR(2) * tan(t0 + D1 * PYR(0) )) / S 
       x1 = tau**PYR(0) 
       x2 = tau / x1
      Rpar(7) = x1
      Rpar(8) = x2
       Wht = (-DLOG(tau)) * D1 / WR(2) / S  / tau
      zn = (tau*S - WR(1)**2)**2 + WR(2)**2 
      Wht = Wht * zn
**
      Q(5) = dsqrt(S*tau)
      Q(4) = (x1 + x2)*par(3) / 2.d0
      Q(3) = (x1 - x2)*par(3) / 2.d0
      Q(2) = 0.d0
      Q(1) = 0.d0
       pq1(4) = (s*tau + q1(5)**2 - q2(5)**2) / 2.d0 / Q(5)
       pq1(3) = dsqrt(pq1(4)**2 - q1(5)**2) 
       pq1(5) = q1(5)
*        q2(4) = Q(5) - q1(4) 
*        q2(3) = -q1(3) 
* now PP is momentum of 1-particle in the rest frame of Q 
      call lorenb_s(Q, pq1, q1) ! Lorentz transformation into initial frame
       q1(1) = 0.d0
       q1(2) = 0.d0
      q2(4) = Q(4) - q1(4)
      q2(3) = Q(3) - q1(3)
      q2(1) = 0.d0
      q2(2) = 0.d0
       return
       end
